const verify = (function(W) {
  const bitId_Protocol = "14kxqYv3emHGwf8m6YgSYLQkGCvn9Qrgr9";

  function genDataToSign(tx) {
	  let data2sign = "";
	  //console.log(tx);
	  tx.inputs.forEach((inp) => {
		  data2sign += inp.prevTxId.toString("hex") + inp.outputIndex;
	  });
	  tx.outputs.forEach((out) => {
		  const sc = new filepay.bsv.Script.fromBuffer(out._scriptBuffer);
		  const sc_len = sc.chunks.length;
		  if (sc.chunks[1].opcodenum == 106) {
			  if (sc.chunks[2].buf.toString() == bitId_Protocol) {
				  console.log(
					  "found bitID. PublicKey=" + sc.chunks[3].buf.toString()
				  );
				  data2sign += sc.chunks[3].buf.toString(); //public key
			  } else {
				  data2sign += sc.toHex();
			  }
		  } else {
			  data2sign += sc.toHex() + out._satoshis;
		  }
	  });
	  return data2sign;
  }

  function verifyID(rawtx) {
		const tx = filepay.bsv.Transaction(rawtx);
		//console.log(tx);
		const data2sign = genDataToSign(tx);
		//console.log("data2sign====="+data2sign);
		const bids = getBitId(tx);
		console.log(bids);
		var hash = filepay.bsv.crypto.Hash.sha256(filepay.bsv.deps.Buffer.from(data2sign));
		//	console.log("hash="+hash.toString('hex'));
		//	console.log("sig="+sig.sig.toString());
		//	console.log("pubkey="+sig.publicKey.toString('hex'));
		bids.forEach((bid) => {
			var verified = filepay.bsv.crypto.ECDSA.verify(hash, bid.sig, bid.publicKey);
			return verified;
		});
		return true;
	}

  function getBitId(tx) {
		let ret = [];
		tx.outputs.forEach((out) => {
			const sc = new filepay.bsv.Script.fromBuffer(out._scriptBuffer);
			const sc_len = sc.chunks.length;
			if (sc.chunks[1].opcodenum == 106) {
				if (sc.chunks[2].buf.toString() == bitId_Protocol) {
				  var sig_str = sc.chunks[4].buf.toString();
					if(sig_str.match(/^[ ]+$/))
					  return;
					const pk = filepay.bsv.PublicKey.fromString(
						sc.chunks[3].buf.toString()
					);
					const sig = filepay.bsv.crypto.Signature.fromString(
						sc.chunks[4].buf.toString()
					);
					ret.push({ publicKey: pk, sig: sig });
				}
			}
		});
		return ret;
  }

  return {
    verifyID,
  }

})(window);