(function (global, factory) {
	typeof exports === 'object' && typeof module !== 'undefined' ? module.exports = factory() :
		typeof define === 'function' && define.amd ? define(factory) :
			(global = typeof globalThis !== 'undefined' ? globalThis : global || self, global.opay = factory());
}(this, (function () {
	'use strict';

	var commonjsGlobal = typeof globalThis !== 'undefined' ? globalThis : typeof window !== 'undefined' ? window : typeof global !== 'undefined' ? global : typeof self !== 'undefined' ? self : {};

	function createCommonjsModule(fn, module) {
		return module = { exports: {} }, fn(module, module.exports), module.exports;
	}

	var check = function (it) {
		return it && it.Math == Math && it;
	};

	// https://github.com/zloirock/core-js/issues/86#issuecomment-115759028
	var global_1 =
		// eslint-disable-next-line no-undef
		check(typeof globalThis == 'object' && globalThis) ||
		check(typeof window == 'object' && window) ||
		check(typeof self == 'object' && self) ||
		check(typeof commonjsGlobal == 'object' && commonjsGlobal) ||
		// eslint-disable-next-line no-new-func
		Function('return this')();

	var fails = function (exec) {
		try {
			return !!exec();
		} catch (error) {
			return true;
		}
	};

	// Thank's IE8 for his funny defineProperty
	var descriptors = !fails(function () {
		return Object.defineProperty({}, 1, { get: function () { return 7; } })[1] != 7;
	});

	var nativePropertyIsEnumerable = {}.propertyIsEnumerable;
	var getOwnPropertyDescriptor = Object.getOwnPropertyDescriptor;

	// Nashorn ~ JDK8 bug
	var NASHORN_BUG = getOwnPropertyDescriptor && !nativePropertyIsEnumerable.call({ 1: 2 }, 1);

	// `Object.prototype.propertyIsEnumerable` method implementation
	// https://tc39.github.io/ecma262/#sec-object.prototype.propertyisenumerable
	var f = NASHORN_BUG ? function propertyIsEnumerable(V) {
		var descriptor = getOwnPropertyDescriptor(this, V);
		return !!descriptor && descriptor.enumerable;
	} : nativePropertyIsEnumerable;

	var objectPropertyIsEnumerable = {
		f: f
	};

	var createPropertyDescriptor = function (bitmap, value) {
		return {
			enumerable: !(bitmap & 1),
			configurable: !(bitmap & 2),
			writable: !(bitmap & 4),
			value: value
		};
	};

	var toString = {}.toString;

	var classofRaw = function (it) {
		return toString.call(it).slice(8, -1);
	};

	var split = ''.split;

	// fallback for non-array-like ES3 and non-enumerable old V8 strings
	var indexedObject = fails(function () {
		// throws an error in rhino, see https://github.com/mozilla/rhino/issues/346
		// eslint-disable-next-line no-prototype-builtins
		return !Object('z').propertyIsEnumerable(0);
	}) ? function (it) {
		return classofRaw(it) == 'String' ? split.call(it, '') : Object(it);
	} : Object;

	// `RequireObjectCoercible` abstract operation
	// https://tc39.github.io/ecma262/#sec-requireobjectcoercible
	var requireObjectCoercible = function (it) {
		if (it == undefined) throw TypeError("Can't call method on " + it);
		return it;
	};

	// toObject with fallback for non-array-like ES3 strings



	var toIndexedObject = function (it) {
		return indexedObject(requireObjectCoercible(it));
	};

	var isObject = function (it) {
		return typeof it === 'object' ? it !== null : typeof it === 'function';
	};

	// `ToPrimitive` abstract operation
	// https://tc39.github.io/ecma262/#sec-toprimitive
	// instead of the ES6 spec version, we didn't implement @@toPrimitive case
	// and the second argument - flag - preferred type is a string
	var toPrimitive = function (input, PREFERRED_STRING) {
		if (!isObject(input)) return input;
		var fn, val;
		if (PREFERRED_STRING && typeof (fn = input.toString) == 'function' && !isObject(val = fn.call(input))) return val;
		if (typeof (fn = input.valueOf) == 'function' && !isObject(val = fn.call(input))) return val;
		if (!PREFERRED_STRING && typeof (fn = input.toString) == 'function' && !isObject(val = fn.call(input))) return val;
		throw TypeError("Can't convert object to primitive value");
	};

	var hasOwnProperty = {}.hasOwnProperty;

	var has = function (it, key) {
		return hasOwnProperty.call(it, key);
	};

	var document$1 = global_1.document;
	// typeof document.createElement is 'object' in old IE
	var EXISTS = isObject(document$1) && isObject(document$1.createElement);

	var documentCreateElement = function (it) {
		return EXISTS ? document$1.createElement(it) : {};
	};

	// Thank's IE8 for his funny defineProperty
	var ie8DomDefine = !descriptors && !fails(function () {
		return Object.defineProperty(documentCreateElement('div'), 'a', {
			get: function () { return 7; }
		}).a != 7;
	});

	var nativeGetOwnPropertyDescriptor = Object.getOwnPropertyDescriptor;

	// `Object.getOwnPropertyDescriptor` method
	// https://tc39.github.io/ecma262/#sec-object.getownpropertydescriptor
	var f$1 = descriptors ? nativeGetOwnPropertyDescriptor : function getOwnPropertyDescriptor(O, P) {
		O = toIndexedObject(O);
		P = toPrimitive(P, true);
		if (ie8DomDefine) try {
			return nativeGetOwnPropertyDescriptor(O, P);
		} catch (error) { /* empty */ }
		if (has(O, P)) return createPropertyDescriptor(!objectPropertyIsEnumerable.f.call(O, P), O[P]);
	};

	var objectGetOwnPropertyDescriptor = {
		f: f$1
	};

	var anObject = function (it) {
		if (!isObject(it)) {
			throw TypeError(String(it) + ' is not an object');
		} return it;
	};

	var nativeDefineProperty = Object.defineProperty;

	// `Object.defineProperty` method
	// https://tc39.github.io/ecma262/#sec-object.defineproperty
	var f$2 = descriptors ? nativeDefineProperty : function defineProperty(O, P, Attributes) {
		anObject(O);
		P = toPrimitive(P, true);
		anObject(Attributes);
		if (ie8DomDefine) try {
			return nativeDefineProperty(O, P, Attributes);
		} catch (error) { /* empty */ }
		if ('get' in Attributes || 'set' in Attributes) throw TypeError('Accessors not supported');
		if ('value' in Attributes) O[P] = Attributes.value;
		return O;
	};

	var objectDefineProperty = {
		f: f$2
	};

	var createNonEnumerableProperty = descriptors ? function (object, key, value) {
		return objectDefineProperty.f(object, key, createPropertyDescriptor(1, value));
	} : function (object, key, value) {
		object[key] = value;
		return object;
	};

	var setGlobal = function (key, value) {
		try {
			createNonEnumerableProperty(global_1, key, value);
		} catch (error) {
			global_1[key] = value;
		} return value;
	};

	var SHARED = '__core-js_shared__';
	var store = global_1[SHARED] || setGlobal(SHARED, {});

	var sharedStore = store;

	var functionToString = Function.toString;

	// this helper broken in `3.4.1-3.4.4`, so we can't use `shared` helper
	if (typeof sharedStore.inspectSource != 'function') {
		sharedStore.inspectSource = function (it) {
			return functionToString.call(it);
		};
	}

	var inspectSource = sharedStore.inspectSource;

	var WeakMap = global_1.WeakMap;

	var nativeWeakMap = typeof WeakMap === 'function' && /native code/.test(inspectSource(WeakMap));

	var shared = createCommonjsModule(function (module) {
		(module.exports = function (key, value) {
			return sharedStore[key] || (sharedStore[key] = value !== undefined ? value : {});
		})('versions', []).push({
			version: '3.6.5',
			mode: 'global',
			copyright: '© 2020 Denis Pushkarev (zloirock.ru)'
		});
	});

	var id = 0;
	var postfix = Math.random();

	var uid = function (key) {
		return 'Symbol(' + String(key === undefined ? '' : key) + ')_' + (++id + postfix).toString(36);
	};

	var keys = shared('keys');

	var sharedKey = function (key) {
		return keys[key] || (keys[key] = uid(key));
	};

	var hiddenKeys = {};

	var WeakMap$1 = global_1.WeakMap;
	var set, get, has$1;

	var enforce = function (it) {
		return has$1(it) ? get(it) : set(it, {});
	};

	var getterFor = function (TYPE) {
		return function (it) {
			var state;
			if (!isObject(it) || (state = get(it)).type !== TYPE) {
				throw TypeError('Incompatible receiver, ' + TYPE + ' required');
			} return state;
		};
	};

	if (nativeWeakMap) {
		var store$1 = new WeakMap$1();
		var wmget = store$1.get;
		var wmhas = store$1.has;
		var wmset = store$1.set;
		set = function (it, metadata) {
			wmset.call(store$1, it, metadata);
			return metadata;
		};
		get = function (it) {
			return wmget.call(store$1, it) || {};
		};
		has$1 = function (it) {
			return wmhas.call(store$1, it);
		};
	} else {
		var STATE = sharedKey('state');
		hiddenKeys[STATE] = true;
		set = function (it, metadata) {
			createNonEnumerableProperty(it, STATE, metadata);
			return metadata;
		};
		get = function (it) {
			return has(it, STATE) ? it[STATE] : {};
		};
		has$1 = function (it) {
			return has(it, STATE);
		};
	}

	var internalState = {
		set: set,
		get: get,
		has: has$1,
		enforce: enforce,
		getterFor: getterFor
	};

	var redefine = createCommonjsModule(function (module) {
		var getInternalState = internalState.get;
		var enforceInternalState = internalState.enforce;
		var TEMPLATE = String(String).split('String');

		(module.exports = function (O, key, value, options) {
			var unsafe = options ? !!options.unsafe : false;
			var simple = options ? !!options.enumerable : false;
			var noTargetGet = options ? !!options.noTargetGet : false;
			if (typeof value == 'function') {
				if (typeof key == 'string' && !has(value, 'name')) createNonEnumerableProperty(value, 'name', key);
				enforceInternalState(value).source = TEMPLATE.join(typeof key == 'string' ? key : '');
			}
			if (O === global_1) {
				if (simple) O[key] = value;
				else setGlobal(key, value);
				return;
			} else if (!unsafe) {
				delete O[key];
			} else if (!noTargetGet && O[key]) {
				simple = true;
			}
			if (simple) O[key] = value;
			else createNonEnumerableProperty(O, key, value);
			// add fake Function#toString for correct work wrapped methods / constructors with methods like LoDash isNative
		})(Function.prototype, 'toString', function toString() {
			return typeof this == 'function' && getInternalState(this).source || inspectSource(this);
		});
	});

	var path = global_1;

	var aFunction = function (variable) {
		return typeof variable == 'function' ? variable : undefined;
	};

	var getBuiltIn = function (namespace, method) {
		return arguments.length < 2 ? aFunction(path[namespace]) || aFunction(global_1[namespace])
			: path[namespace] && path[namespace][method] || global_1[namespace] && global_1[namespace][method];
	};

	var ceil = Math.ceil;
	var floor = Math.floor;

	// `ToInteger` abstract operation
	// https://tc39.github.io/ecma262/#sec-tointeger
	var toInteger = function (argument) {
		return isNaN(argument = +argument) ? 0 : (argument > 0 ? floor : ceil)(argument);
	};

	var min = Math.min;

	// `ToLength` abstract operation
	// https://tc39.github.io/ecma262/#sec-tolength
	var toLength = function (argument) {
		return argument > 0 ? min(toInteger(argument), 0x1FFFFFFFFFFFFF) : 0; // 2 ** 53 - 1 == 9007199254740991
	};

	var max = Math.max;
	var min$1 = Math.min;

	// Helper for a popular repeating case of the spec:
	// Let integer be ? ToInteger(index).
	// If integer < 0, let result be max((length + integer), 0); else let result be min(integer, length).
	var toAbsoluteIndex = function (index, length) {
		var integer = toInteger(index);
		return integer < 0 ? max(integer + length, 0) : min$1(integer, length);
	};

	// `Array.prototype.{ indexOf, includes }` methods implementation
	var createMethod = function (IS_INCLUDES) {
		return function ($this, el, fromIndex) {
			var O = toIndexedObject($this);
			var length = toLength(O.length);
			var index = toAbsoluteIndex(fromIndex, length);
			var value;
			// Array#includes uses SameValueZero equality algorithm
			// eslint-disable-next-line no-self-compare
			if (IS_INCLUDES && el != el) while (length > index) {
				value = O[index++];
				// eslint-disable-next-line no-self-compare
				if (value != value) return true;
				// Array#indexOf ignores holes, Array#includes - not
			} else for (; length > index; index++) {
				if ((IS_INCLUDES || index in O) && O[index] === el) return IS_INCLUDES || index || 0;
			} return !IS_INCLUDES && -1;
		};
	};

	var arrayIncludes = {
		// `Array.prototype.includes` method
		// https://tc39.github.io/ecma262/#sec-array.prototype.includes
		includes: createMethod(true),
		// `Array.prototype.indexOf` method
		// https://tc39.github.io/ecma262/#sec-array.prototype.indexof
		indexOf: createMethod(false)
	};

	var indexOf = arrayIncludes.indexOf;


	var objectKeysInternal = function (object, names) {
		var O = toIndexedObject(object);
		var i = 0;
		var result = [];
		var key;
		for (key in O) !has(hiddenKeys, key) && has(O, key) && result.push(key);
		// Don't enum bug & hidden keys
		while (names.length > i) if (has(O, key = names[i++])) {
			~indexOf(result, key) || result.push(key);
		}
		return result;
	};

	// IE8- don't enum bug keys
	var enumBugKeys = [
		'constructor',
		'hasOwnProperty',
		'isPrototypeOf',
		'propertyIsEnumerable',
		'toLocaleString',
		'toString',
		'valueOf'
	];

	var hiddenKeys$1 = enumBugKeys.concat('length', 'prototype');

	// `Object.getOwnPropertyNames` method
	// https://tc39.github.io/ecma262/#sec-object.getownpropertynames
	var f$3 = Object.getOwnPropertyNames || function getOwnPropertyNames(O) {
		return objectKeysInternal(O, hiddenKeys$1);
	};

	var objectGetOwnPropertyNames = {
		f: f$3
	};

	var f$4 = Object.getOwnPropertySymbols;

	var objectGetOwnPropertySymbols = {
		f: f$4
	};

	// all object keys, includes non-enumerable and symbols
	var ownKeys = getBuiltIn('Reflect', 'ownKeys') || function ownKeys(it) {
		var keys = objectGetOwnPropertyNames.f(anObject(it));
		var getOwnPropertySymbols = objectGetOwnPropertySymbols.f;
		return getOwnPropertySymbols ? keys.concat(getOwnPropertySymbols(it)) : keys;
	};

	var copyConstructorProperties = function (target, source) {
		var keys = ownKeys(source);
		var defineProperty = objectDefineProperty.f;
		var getOwnPropertyDescriptor = objectGetOwnPropertyDescriptor.f;
		for (var i = 0; i < keys.length; i++) {
			var key = keys[i];
			if (!has(target, key)) defineProperty(target, key, getOwnPropertyDescriptor(source, key));
		}
	};

	var replacement = /#|\.prototype\./;

	var isForced = function (feature, detection) {
		var value = data[normalize(feature)];
		return value == POLYFILL ? true
			: value == NATIVE ? false
				: typeof detection == 'function' ? fails(detection)
					: !!detection;
	};

	var normalize = isForced.normalize = function (string) {
		return String(string).replace(replacement, '.').toLowerCase();
	};

	var data = isForced.data = {};
	var NATIVE = isForced.NATIVE = 'N';
	var POLYFILL = isForced.POLYFILL = 'P';

	var isForced_1 = isForced;

	var getOwnPropertyDescriptor$1 = objectGetOwnPropertyDescriptor.f;






	/*
		options.target      - name of the target object
		options.global      - target is the global object
		options.stat        - export as static methods of target
		options.proto       - export as prototype methods of target
		options.real        - real prototype method for the `pure` version
		options.forced      - export even if the native feature is available
		options.bind        - bind methods to the target, required for the `pure` version
		options.wrap        - wrap constructors to preventing global pollution, required for the `pure` version
		options.unsafe      - use the simple assignment of property instead of delete + defineProperty
		options.sham        - add a flag to not completely full polyfills
		options.enumerable  - export as enumerable property
		options.noTargetGet - prevent calling a getter on target
	*/
	var _export = function (options, source) {
		var TARGET = options.target;
		var GLOBAL = options.global;
		var STATIC = options.stat;
		var FORCED, target, key, targetProperty, sourceProperty, descriptor;
		if (GLOBAL) {
			target = global_1;
		} else if (STATIC) {
			target = global_1[TARGET] || setGlobal(TARGET, {});
		} else {
			target = (global_1[TARGET] || {}).prototype;
		}
		if (target) for (key in source) {
			sourceProperty = source[key];
			if (options.noTargetGet) {
				descriptor = getOwnPropertyDescriptor$1(target, key);
				targetProperty = descriptor && descriptor.value;
			} else targetProperty = target[key];
			FORCED = isForced_1(GLOBAL ? key : TARGET + (STATIC ? '.' : '#') + key, options.forced);
			// contained in target
			if (!FORCED && targetProperty !== undefined) {
				if (typeof sourceProperty === typeof targetProperty) continue;
				copyConstructorProperties(sourceProperty, targetProperty);
			}
			// add a flag to not completely full polyfills
			if (options.sham || (targetProperty && targetProperty.sham)) {
				createNonEnumerableProperty(sourceProperty, 'sham', true);
			}
			// extend global
			redefine(target, key, sourceProperty, options);
		}
	};

	var aFunction$1 = function (it) {
		if (typeof it != 'function') {
			throw TypeError(String(it) + ' is not a function');
		} return it;
	};

	// optional / simple context binding
	var functionBindContext = function (fn, that, length) {
		aFunction$1(fn);
		if (that === undefined) return fn;
		switch (length) {
			case 0: return function () {
				return fn.call(that);
			};
			case 1: return function (a) {
				return fn.call(that, a);
			};
			case 2: return function (a, b) {
				return fn.call(that, a, b);
			};
			case 3: return function (a, b, c) {
				return fn.call(that, a, b, c);
			};
		}
		return function (/* ...args */) {
			return fn.apply(that, arguments);
		};
	};

	// `ToObject` abstract operation
	// https://tc39.github.io/ecma262/#sec-toobject
	var toObject = function (argument) {
		return Object(requireObjectCoercible(argument));
	};

	// `IsArray` abstract operation
	// https://tc39.github.io/ecma262/#sec-isarray
	var isArray = Array.isArray || function isArray(arg) {
		return classofRaw(arg) == 'Array';
	};

	var nativeSymbol = !!Object.getOwnPropertySymbols && !fails(function () {
		// Chrome 38 Symbol has incorrect toString conversion
		// eslint-disable-next-line no-undef
		return !String(Symbol());
	});

	var useSymbolAsUid = nativeSymbol
		// eslint-disable-next-line no-undef
		&& !Symbol.sham
		// eslint-disable-next-line no-undef
		&& typeof Symbol.iterator == 'symbol';

	var WellKnownSymbolsStore = shared('wks');
	var Symbol$1 = global_1.Symbol;
	var createWellKnownSymbol = useSymbolAsUid ? Symbol$1 : Symbol$1 && Symbol$1.withoutSetter || uid;

	var wellKnownSymbol = function (name) {
		if (!has(WellKnownSymbolsStore, name)) {
			if (nativeSymbol && has(Symbol$1, name)) WellKnownSymbolsStore[name] = Symbol$1[name];
			else WellKnownSymbolsStore[name] = createWellKnownSymbol('Symbol.' + name);
		} return WellKnownSymbolsStore[name];
	};

	var SPECIES = wellKnownSymbol('species');

	// `ArraySpeciesCreate` abstract operation
	// https://tc39.github.io/ecma262/#sec-arrayspeciescreate
	var arraySpeciesCreate = function (originalArray, length) {
		var C;
		if (isArray(originalArray)) {
			C = originalArray.constructor;
			// cross-realm fallback
			if (typeof C == 'function' && (C === Array || isArray(C.prototype))) C = undefined;
			else if (isObject(C)) {
				C = C[SPECIES];
				if (C === null) C = undefined;
			}
		} return new (C === undefined ? Array : C)(length === 0 ? 0 : length);
	};

	var push = [].push;

	// `Array.prototype.{ forEach, map, filter, some, every, find, findIndex }` methods implementation
	var createMethod$1 = function (TYPE) {
		var IS_MAP = TYPE == 1;
		var IS_FILTER = TYPE == 2;
		var IS_SOME = TYPE == 3;
		var IS_EVERY = TYPE == 4;
		var IS_FIND_INDEX = TYPE == 6;
		var NO_HOLES = TYPE == 5 || IS_FIND_INDEX;
		return function ($this, callbackfn, that, specificCreate) {
			var O = toObject($this);
			var self = indexedObject(O);
			var boundFunction = functionBindContext(callbackfn, that, 3);
			var length = toLength(self.length);
			var index = 0;
			var create = specificCreate || arraySpeciesCreate;
			var target = IS_MAP ? create($this, length) : IS_FILTER ? create($this, 0) : undefined;
			var value, result;
			for (; length > index; index++) if (NO_HOLES || index in self) {
				value = self[index];
				result = boundFunction(value, index, O);
				if (TYPE) {
					if (IS_MAP) target[index] = result; // map
					else if (result) switch (TYPE) {
						case 3: return true;              // some
						case 5: return value;             // find
						case 6: return index;             // findIndex
						case 2: push.call(target, value); // filter
					} else if (IS_EVERY) return false;  // every
				}
			}
			return IS_FIND_INDEX ? -1 : IS_SOME || IS_EVERY ? IS_EVERY : target;
		};
	};

	var arrayIteration = {
		// `Array.prototype.forEach` method
		// https://tc39.github.io/ecma262/#sec-array.prototype.foreach
		forEach: createMethod$1(0),
		// `Array.prototype.map` method
		// https://tc39.github.io/ecma262/#sec-array.prototype.map
		map: createMethod$1(1),
		// `Array.prototype.filter` method
		// https://tc39.github.io/ecma262/#sec-array.prototype.filter
		filter: createMethod$1(2),
		// `Array.prototype.some` method
		// https://tc39.github.io/ecma262/#sec-array.prototype.some
		some: createMethod$1(3),
		// `Array.prototype.every` method
		// https://tc39.github.io/ecma262/#sec-array.prototype.every
		every: createMethod$1(4),
		// `Array.prototype.find` method
		// https://tc39.github.io/ecma262/#sec-array.prototype.find
		find: createMethod$1(5),
		// `Array.prototype.findIndex` method
		// https://tc39.github.io/ecma262/#sec-array.prototype.findIndex
		findIndex: createMethod$1(6)
	};

	var arrayMethodIsStrict = function (METHOD_NAME, argument) {
		var method = [][METHOD_NAME];
		return !!method && fails(function () {
			// eslint-disable-next-line no-useless-call,no-throw-literal
			method.call(null, argument || function () { throw 1; }, 1);
		});
	};

	var defineProperty = Object.defineProperty;
	var cache = {};

	var thrower = function (it) { throw it; };

	var arrayMethodUsesToLength = function (METHOD_NAME, options) {
		if (has(cache, METHOD_NAME)) return cache[METHOD_NAME];
		if (!options) options = {};
		var method = [][METHOD_NAME];
		var ACCESSORS = has(options, 'ACCESSORS') ? options.ACCESSORS : false;
		var argument0 = has(options, 0) ? options[0] : thrower;
		var argument1 = has(options, 1) ? options[1] : undefined;

		return cache[METHOD_NAME] = !!method && !fails(function () {
			if (ACCESSORS && !descriptors) return true;
			var O = { length: -1 };

			if (ACCESSORS) defineProperty(O, 1, { enumerable: true, get: thrower });
			else O[1] = 1;

			method.call(O, argument0, argument1);
		});
	};

	var $forEach = arrayIteration.forEach;



	var STRICT_METHOD = arrayMethodIsStrict('forEach');
	var USES_TO_LENGTH = arrayMethodUsesToLength('forEach');

	// `Array.prototype.forEach` method implementation
	// https://tc39.github.io/ecma262/#sec-array.prototype.foreach
	var arrayForEach = (!STRICT_METHOD || !USES_TO_LENGTH) ? function forEach(callbackfn /* , thisArg */) {
		return $forEach(this, callbackfn, arguments.length > 1 ? arguments[1] : undefined);
	} : [].forEach;

	// `Array.prototype.forEach` method
	// https://tc39.github.io/ecma262/#sec-array.prototype.foreach
	_export({ target: 'Array', proto: true, forced: [].forEach != arrayForEach }, {
		forEach: arrayForEach
	});

	var min$2 = Math.min;
	var nativeLastIndexOf = [].lastIndexOf;
	var NEGATIVE_ZERO = !!nativeLastIndexOf && 1 / [1].lastIndexOf(1, -0) < 0;
	var STRICT_METHOD$1 = arrayMethodIsStrict('lastIndexOf');
	// For preventing possible almost infinite loop in non-standard implementations, test the forward version of the method
	var USES_TO_LENGTH$1 = arrayMethodUsesToLength('indexOf', { ACCESSORS: true, 1: 0 });
	var FORCED = NEGATIVE_ZERO || !STRICT_METHOD$1 || !USES_TO_LENGTH$1;

	// `Array.prototype.lastIndexOf` method implementation
	// https://tc39.github.io/ecma262/#sec-array.prototype.lastindexof
	var arrayLastIndexOf = FORCED ? function lastIndexOf(searchElement /* , fromIndex = @[*-1] */) {
		// convert -0 to +0
		if (NEGATIVE_ZERO) return nativeLastIndexOf.apply(this, arguments) || 0;
		var O = toIndexedObject(this);
		var length = toLength(O.length);
		var index = length - 1;
		if (arguments.length > 1) index = min$2(index, toInteger(arguments[1]));
		if (index < 0) index = length + index;
		for (; index >= 0; index--) if (index in O && O[index] === searchElement) return index || 0;
		return -1;
	} : nativeLastIndexOf;

	// `Array.prototype.lastIndexOf` method
	// https://tc39.github.io/ecma262/#sec-array.prototype.lastindexof
	_export({ target: 'Array', proto: true, forced: arrayLastIndexOf !== [].lastIndexOf }, {
		lastIndexOf: arrayLastIndexOf
	});

	var createProperty = function (object, key, value) {
		var propertyKey = toPrimitive(key);
		if (propertyKey in object) objectDefineProperty.f(object, propertyKey, createPropertyDescriptor(0, value));
		else object[propertyKey] = value;
	};

	var engineUserAgent = getBuiltIn('navigator', 'userAgent') || '';

	var process = global_1.process;
	var versions = process && process.versions;
	var v8 = versions && versions.v8;
	var match, version;

	if (v8) {
		match = v8.split('.');
		version = match[0] + match[1];
	} else if (engineUserAgent) {
		match = engineUserAgent.match(/Edge\/(\d+)/);
		if (!match || match[1] >= 74) {
			match = engineUserAgent.match(/Chrome\/(\d+)/);
			if (match) version = match[1];
		}
	}

	var engineV8Version = version && +version;

	var SPECIES$1 = wellKnownSymbol('species');

	var arrayMethodHasSpeciesSupport = function (METHOD_NAME) {
		// We can't use this feature detection in V8 since it causes
		// deoptimization and serious performance degradation
		// https://github.com/zloirock/core-js/issues/677
		return engineV8Version >= 51 || !fails(function () {
			var array = [];
			var constructor = array.constructor = {};
			constructor[SPECIES$1] = function () {
				return { foo: 1 };
			};
			return array[METHOD_NAME](Boolean).foo !== 1;
		});
	};

	var HAS_SPECIES_SUPPORT = arrayMethodHasSpeciesSupport('slice');
	var USES_TO_LENGTH$2 = arrayMethodUsesToLength('slice', { ACCESSORS: true, 0: 0, 1: 2 });

	var SPECIES$2 = wellKnownSymbol('species');
	var nativeSlice = [].slice;
	var max$1 = Math.max;

	// `Array.prototype.slice` method
	// https://tc39.github.io/ecma262/#sec-array.prototype.slice
	// fallback for not array-like ES3 strings and DOM objects
	_export({ target: 'Array', proto: true, forced: !HAS_SPECIES_SUPPORT || !USES_TO_LENGTH$2 }, {
		slice: function slice(start, end) {
			var O = toIndexedObject(this);
			var length = toLength(O.length);
			var k = toAbsoluteIndex(start, length);
			var fin = toAbsoluteIndex(end === undefined ? length : end, length);
			// inline `ArraySpeciesCreate` for usage native `Array#slice` where it's possible
			var Constructor, result, n;
			if (isArray(O)) {
				Constructor = O.constructor;
				// cross-realm fallback
				if (typeof Constructor == 'function' && (Constructor === Array || isArray(Constructor.prototype))) {
					Constructor = undefined;
				} else if (isObject(Constructor)) {
					Constructor = Constructor[SPECIES$2];
					if (Constructor === null) Constructor = undefined;
				}
				if (Constructor === Array || Constructor === undefined) {
					return nativeSlice.call(O, k, fin);
				}
			}
			result = new (Constructor === undefined ? Array : Constructor)(max$1(fin - k, 0));
			for (n = 0; k < fin; k++, n++) if (k in O) createProperty(result, n, O[k]);
			result.length = n;
			return result;
		}
	});

	var defineProperty$1 = objectDefineProperty.f;

	var FunctionPrototype = Function.prototype;
	var FunctionPrototypeToString = FunctionPrototype.toString;
	var nameRE = /^\s*function ([^ (]*)/;
	var NAME = 'name';

	// Function instances `.name` property
	// https://tc39.github.io/ecma262/#sec-function-instances-name
	if (descriptors && !(NAME in FunctionPrototype)) {
		defineProperty$1(FunctionPrototype, NAME, {
			configurable: true,
			get: function () {
				try {
					return FunctionPrototypeToString.call(this).match(nameRE)[1];
				} catch (error) {
					return '';
				}
			}
		});
	}

	// `Object.keys` method
	// https://tc39.github.io/ecma262/#sec-object.keys
	var objectKeys = Object.keys || function keys(O) {
		return objectKeysInternal(O, enumBugKeys);
	};

	var FAILS_ON_PRIMITIVES = fails(function () { objectKeys(1); });

	// `Object.keys` method
	// https://tc39.github.io/ecma262/#sec-object.keys
	_export({ target: 'Object', stat: true, forced: FAILS_ON_PRIMITIVES }, {
		keys: function keys(it) {
			return objectKeys(toObject(it));
		}
	});

	var TO_STRING_TAG = wellKnownSymbol('toStringTag');
	var test = {};

	test[TO_STRING_TAG] = 'z';

	var toStringTagSupport = String(test) === '[object z]';

	var TO_STRING_TAG$1 = wellKnownSymbol('toStringTag');
	// ES3 wrong here
	var CORRECT_ARGUMENTS = classofRaw(function () { return arguments; }()) == 'Arguments';

	// fallback for IE11 Script Access Denied error
	var tryGet = function (it, key) {
		try {
			return it[key];
		} catch (error) { /* empty */ }
	};

	// getting tag from ES6+ `Object.prototype.toString`
	var classof = toStringTagSupport ? classofRaw : function (it) {
		var O, tag, result;
		return it === undefined ? 'Undefined' : it === null ? 'Null'
			// @@toStringTag case
			: typeof (tag = tryGet(O = Object(it), TO_STRING_TAG$1)) == 'string' ? tag
				// builtinTag case
				: CORRECT_ARGUMENTS ? classofRaw(O)
					// ES3 arguments fallback
					: (result = classofRaw(O)) == 'Object' && typeof O.callee == 'function' ? 'Arguments' : result;
	};

	// `Object.prototype.toString` method implementation
	// https://tc39.github.io/ecma262/#sec-object.prototype.tostring
	var objectToString = toStringTagSupport ? {}.toString : function toString() {
		return '[object ' + classof(this) + ']';
	};

	// `Object.prototype.toString` method
	// https://tc39.github.io/ecma262/#sec-object.prototype.tostring
	if (!toStringTagSupport) {
		redefine(Object.prototype, 'toString', objectToString, { unsafe: true });
	}

	var nativePromiseConstructor = global_1.Promise;

	var redefineAll = function (target, src, options) {
		for (var key in src) redefine(target, key, src[key], options);
		return target;
	};

	var defineProperty$2 = objectDefineProperty.f;



	var TO_STRING_TAG$2 = wellKnownSymbol('toStringTag');

	var setToStringTag = function (it, TAG, STATIC) {
		if (it && !has(it = STATIC ? it : it.prototype, TO_STRING_TAG$2)) {
			defineProperty$2(it, TO_STRING_TAG$2, { configurable: true, value: TAG });
		}
	};

	var SPECIES$3 = wellKnownSymbol('species');

	var setSpecies = function (CONSTRUCTOR_NAME) {
		var Constructor = getBuiltIn(CONSTRUCTOR_NAME);
		var defineProperty = objectDefineProperty.f;

		if (descriptors && Constructor && !Constructor[SPECIES$3]) {
			defineProperty(Constructor, SPECIES$3, {
				configurable: true,
				get: function () { return this; }
			});
		}
	};

	var anInstance = function (it, Constructor, name) {
		if (!(it instanceof Constructor)) {
			throw TypeError('Incorrect ' + (name ? name + ' ' : '') + 'invocation');
		} return it;
	};

	var iterators = {};

	var ITERATOR = wellKnownSymbol('iterator');
	var ArrayPrototype = Array.prototype;

	// check on default Array iterator
	var isArrayIteratorMethod = function (it) {
		return it !== undefined && (iterators.Array === it || ArrayPrototype[ITERATOR] === it);
	};

	var ITERATOR$1 = wellKnownSymbol('iterator');

	var getIteratorMethod = function (it) {
		if (it != undefined) return it[ITERATOR$1]
			|| it['@@iterator']
			|| iterators[classof(it)];
	};

	// call something on iterator step with safe closing on error
	var callWithSafeIterationClosing = function (iterator, fn, value, ENTRIES) {
		try {
			return ENTRIES ? fn(anObject(value)[0], value[1]) : fn(value);
			// 7.4.6 IteratorClose(iterator, completion)
		} catch (error) {
			var returnMethod = iterator['return'];
			if (returnMethod !== undefined) anObject(returnMethod.call(iterator));
			throw error;
		}
	};

	var iterate_1 = createCommonjsModule(function (module) {
		var Result = function (stopped, result) {
			this.stopped = stopped;
			this.result = result;
		};

		var iterate = module.exports = function (iterable, fn, that, AS_ENTRIES, IS_ITERATOR) {
			var boundFunction = functionBindContext(fn, that, AS_ENTRIES ? 2 : 1);
			var iterator, iterFn, index, length, result, next, step;

			if (IS_ITERATOR) {
				iterator = iterable;
			} else {
				iterFn = getIteratorMethod(iterable);
				if (typeof iterFn != 'function') throw TypeError('Target is not iterable');
				// optimisation for array iterators
				if (isArrayIteratorMethod(iterFn)) {
					for (index = 0, length = toLength(iterable.length); length > index; index++) {
						result = AS_ENTRIES
							? boundFunction(anObject(step = iterable[index])[0], step[1])
							: boundFunction(iterable[index]);
						if (result && result instanceof Result) return result;
					} return new Result(false);
				}
				iterator = iterFn.call(iterable);
			}

			next = iterator.next;
			while (!(step = next.call(iterator)).done) {
				result = callWithSafeIterationClosing(iterator, boundFunction, step.value, AS_ENTRIES);
				if (typeof result == 'object' && result && result instanceof Result) return result;
			} return new Result(false);
		};

		iterate.stop = function (result) {
			return new Result(true, result);
		};
	});

	var ITERATOR$2 = wellKnownSymbol('iterator');
	var SAFE_CLOSING = false;

	try {
		var called = 0;
		var iteratorWithReturn = {
			next: function () {
				return { done: !!called++ };
			},
			'return': function () {
				SAFE_CLOSING = true;
			}
		};
		iteratorWithReturn[ITERATOR$2] = function () {
			return this;
		};
		// eslint-disable-next-line no-throw-literal
		Array.from(iteratorWithReturn, function () { throw 2; });
	} catch (error) { /* empty */ }

	var checkCorrectnessOfIteration = function (exec, SKIP_CLOSING) {
		if (!SKIP_CLOSING && !SAFE_CLOSING) return false;
		var ITERATION_SUPPORT = false;
		try {
			var object = {};
			object[ITERATOR$2] = function () {
				return {
					next: function () {
						return { done: ITERATION_SUPPORT = true };
					}
				};
			};
			exec(object);
		} catch (error) { /* empty */ }
		return ITERATION_SUPPORT;
	};

	var SPECIES$4 = wellKnownSymbol('species');

	// `SpeciesConstructor` abstract operation
	// https://tc39.github.io/ecma262/#sec-speciesconstructor
	var speciesConstructor = function (O, defaultConstructor) {
		var C = anObject(O).constructor;
		var S;
		return C === undefined || (S = anObject(C)[SPECIES$4]) == undefined ? defaultConstructor : aFunction$1(S);
	};

	var html = getBuiltIn('document', 'documentElement');

	var engineIsIos = /(iphone|ipod|ipad).*applewebkit/i.test(engineUserAgent);

	var location = global_1.location;
	var set$1 = global_1.setImmediate;
	var clear = global_1.clearImmediate;
	var process$1 = global_1.process;
	var MessageChannel = global_1.MessageChannel;
	var Dispatch = global_1.Dispatch;
	var counter = 0;
	var queue = {};
	var ONREADYSTATECHANGE = 'onreadystatechange';
	var defer, channel, port;

	var run = function (id) {
		// eslint-disable-next-line no-prototype-builtins
		if (queue.hasOwnProperty(id)) {
			var fn = queue[id];
			delete queue[id];
			fn();
		}
	};

	var runner = function (id) {
		return function () {
			run(id);
		};
	};

	var listener = function (event) {
		run(event.data);
	};

	var post = function (id) {
		// old engines have not location.origin
		global_1.postMessage(id + '', location.protocol + '//' + location.host);
	};

	// Node.js 0.9+ & IE10+ has setImmediate, otherwise:
	if (!set$1 || !clear) {
		set$1 = function setImmediate(fn) {
			var args = [];
			var i = 1;
			while (arguments.length > i) args.push(arguments[i++]);
			queue[++counter] = function () {
				// eslint-disable-next-line no-new-func
				(typeof fn == 'function' ? fn : Function(fn)).apply(undefined, args);
			};
			defer(counter);
			return counter;
		};
		clear = function clearImmediate(id) {
			delete queue[id];
		};
		// Node.js 0.8-
		if (classofRaw(process$1) == 'process') {
			defer = function (id) {
				process$1.nextTick(runner(id));
			};
			// Sphere (JS game engine) Dispatch API
		} else if (Dispatch && Dispatch.now) {
			defer = function (id) {
				Dispatch.now(runner(id));
			};
			// Browsers with MessageChannel, includes WebWorkers
			// except iOS - https://github.com/zloirock/core-js/issues/624
		} else if (MessageChannel && !engineIsIos) {
			channel = new MessageChannel();
			port = channel.port2;
			channel.port1.onmessage = listener;
			defer = functionBindContext(port.postMessage, port, 1);
			// Browsers with postMessage, skip WebWorkers
			// IE8 has postMessage, but it's sync & typeof its postMessage is 'object'
		} else if (
			global_1.addEventListener &&
			typeof postMessage == 'function' &&
			!global_1.importScripts &&
			!fails(post) &&
			location.protocol !== 'file:'
		) {
			defer = post;
			global_1.addEventListener('message', listener, false);
			// IE8-
		} else if (ONREADYSTATECHANGE in documentCreateElement('script')) {
			defer = function (id) {
				html.appendChild(documentCreateElement('script'))[ONREADYSTATECHANGE] = function () {
					html.removeChild(this);
					run(id);
				};
			};
			// Rest old browsers
		} else {
			defer = function (id) {
				setTimeout(runner(id), 0);
			};
		}
	}

	var task = {
		set: set$1,
		clear: clear
	};

	var getOwnPropertyDescriptor$2 = objectGetOwnPropertyDescriptor.f;

	var macrotask = task.set;


	var MutationObserver = global_1.MutationObserver || global_1.WebKitMutationObserver;
	var process$2 = global_1.process;
	var Promise$1 = global_1.Promise;
	var IS_NODE = classofRaw(process$2) == 'process';
	// Node.js 11 shows ExperimentalWarning on getting `queueMicrotask`
	var queueMicrotaskDescriptor = getOwnPropertyDescriptor$2(global_1, 'queueMicrotask');
	var queueMicrotask = queueMicrotaskDescriptor && queueMicrotaskDescriptor.value;

	var flush, head, last, notify, toggle, node, promise, then;

	// modern engines have queueMicrotask method
	if (!queueMicrotask) {
		flush = function () {
			var parent, fn;
			if (IS_NODE && (parent = process$2.domain)) parent.exit();
			while (head) {
				fn = head.fn;
				head = head.next;
				try {
					fn();
				} catch (error) {
					if (head) notify();
					else last = undefined;
					throw error;
				}
			} last = undefined;
			if (parent) parent.enter();
		};

		// Node.js
		if (IS_NODE) {
			notify = function () {
				process$2.nextTick(flush);
			};
			// browsers with MutationObserver, except iOS - https://github.com/zloirock/core-js/issues/339
		} else if (MutationObserver && !engineIsIos) {
			toggle = true;
			node = document.createTextNode('');
			new MutationObserver(flush).observe(node, { characterData: true });
			notify = function () {
				node.data = toggle = !toggle;
			};
			// environments with maybe non-completely correct, but existent Promise
		} else if (Promise$1 && Promise$1.resolve) {
			// Promise.resolve without an argument throws an error in LG WebOS 2
			promise = Promise$1.resolve(undefined);
			then = promise.then;
			notify = function () {
				then.call(promise, flush);
			};
			// for other environments - macrotask based on:
			// - setImmediate
			// - MessageChannel
			// - window.postMessag
			// - onreadystatechange
			// - setTimeout
		} else {
			notify = function () {
				// strange IE + webpack dev server bug - use .call(global)
				macrotask.call(global_1, flush);
			};
		}
	}

	var microtask = queueMicrotask || function (fn) {
		var task = { fn: fn, next: undefined };
		if (last) last.next = task;
		if (!head) {
			head = task;
			notify();
		} last = task;
	};

	var PromiseCapability = function (C) {
		var resolve, reject;
		this.promise = new C(function ($$resolve, $$reject) {
			if (resolve !== undefined || reject !== undefined) throw TypeError('Bad Promise constructor');
			resolve = $$resolve;
			reject = $$reject;
		});
		this.resolve = aFunction$1(resolve);
		this.reject = aFunction$1(reject);
	};

	// 25.4.1.5 NewPromiseCapability(C)
	var f$5 = function (C) {
		return new PromiseCapability(C);
	};

	var newPromiseCapability = {
		f: f$5
	};

	var promiseResolve = function (C, x) {
		anObject(C);
		if (isObject(x) && x.constructor === C) return x;
		var promiseCapability = newPromiseCapability.f(C);
		var resolve = promiseCapability.resolve;
		resolve(x);
		return promiseCapability.promise;
	};

	var hostReportErrors = function (a, b) {
		var console = global_1.console;
		if (console && console.error) {
			arguments.length === 1 ? console.error(a) : console.error(a, b);
		}
	};

	var perform = function (exec) {
		try {
			return { error: false, value: exec() };
		} catch (error) {
			return { error: true, value: error };
		}
	};

	var task$1 = task.set;










	var SPECIES$5 = wellKnownSymbol('species');
	var PROMISE = 'Promise';
	var getInternalState = internalState.get;
	var setInternalState = internalState.set;
	var getInternalPromiseState = internalState.getterFor(PROMISE);
	var PromiseConstructor = nativePromiseConstructor;
	var TypeError$1 = global_1.TypeError;
	var document$2 = global_1.document;
	var process$3 = global_1.process;
	var $fetch = getBuiltIn('fetch');
	var newPromiseCapability$1 = newPromiseCapability.f;
	var newGenericPromiseCapability = newPromiseCapability$1;
	var IS_NODE$1 = classofRaw(process$3) == 'process';
	var DISPATCH_EVENT = !!(document$2 && document$2.createEvent && global_1.dispatchEvent);
	var UNHANDLED_REJECTION = 'unhandledrejection';
	var REJECTION_HANDLED = 'rejectionhandled';
	var PENDING = 0;
	var FULFILLED = 1;
	var REJECTED = 2;
	var HANDLED = 1;
	var UNHANDLED = 2;
	var Internal, OwnPromiseCapability, PromiseWrapper, nativeThen;

	var FORCED$1 = isForced_1(PROMISE, function () {
		var GLOBAL_CORE_JS_PROMISE = inspectSource(PromiseConstructor) !== String(PromiseConstructor);
		if (!GLOBAL_CORE_JS_PROMISE) {
			// V8 6.6 (Node 10 and Chrome 66) have a bug with resolving custom thenables
			// https://bugs.chromium.org/p/chromium/issues/detail?id=830565
			// We can't detect it synchronously, so just check versions
			if (engineV8Version === 66) return true;
			// Unhandled rejections tracking support, NodeJS Promise without it fails @@species test
			if (!IS_NODE$1 && typeof PromiseRejectionEvent != 'function') return true;
		}
		// We can't use @@species feature detection in V8 since it causes
		// deoptimization and performance degradation
		// https://github.com/zloirock/core-js/issues/679
		if (engineV8Version >= 51 && /native code/.test(PromiseConstructor)) return false;
		// Detect correctness of subclassing with @@species support
		var promise = PromiseConstructor.resolve(1);
		var FakePromise = function (exec) {
			exec(function () { /* empty */ }, function () { /* empty */ });
		};
		var constructor = promise.constructor = {};
		constructor[SPECIES$5] = FakePromise;
		return !(promise.then(function () { /* empty */ }) instanceof FakePromise);
	});

	var INCORRECT_ITERATION = FORCED$1 || !checkCorrectnessOfIteration(function (iterable) {
		PromiseConstructor.all(iterable)['catch'](function () { /* empty */ });
	});

	// helpers
	var isThenable = function (it) {
		var then;
		return isObject(it) && typeof (then = it.then) == 'function' ? then : false;
	};

	var notify$1 = function (promise, state, isReject) {
		if (state.notified) return;
		state.notified = true;
		var chain = state.reactions;
		microtask(function () {
			var value = state.value;
			var ok = state.state == FULFILLED;
			var index = 0;
			// variable length - can't use forEach
			while (chain.length > index) {
				var reaction = chain[index++];
				var handler = ok ? reaction.ok : reaction.fail;
				var resolve = reaction.resolve;
				var reject = reaction.reject;
				var domain = reaction.domain;
				var result, then, exited;
				try {
					if (handler) {
						if (!ok) {
							if (state.rejection === UNHANDLED) onHandleUnhandled(promise, state);
							state.rejection = HANDLED;
						}
						if (handler === true) result = value;
						else {
							if (domain) domain.enter();
							result = handler(value); // can throw
							if (domain) {
								domain.exit();
								exited = true;
							}
						}
						if (result === reaction.promise) {
							reject(TypeError$1('Promise-chain cycle'));
						} else if (then = isThenable(result)) {
							then.call(result, resolve, reject);
						} else resolve(result);
					} else reject(value);
				} catch (error) {
					if (domain && !exited) domain.exit();
					reject(error);
				}
			}
			state.reactions = [];
			state.notified = false;
			if (isReject && !state.rejection) onUnhandled(promise, state);
		});
	};

	var dispatchEvent = function (name, promise, reason) {
		var event, handler;
		if (DISPATCH_EVENT) {
			event = document$2.createEvent('Event');
			event.promise = promise;
			event.reason = reason;
			event.initEvent(name, false, true);
			global_1.dispatchEvent(event);
		} else event = { promise: promise, reason: reason };
		if (handler = global_1['on' + name]) handler(event);
		else if (name === UNHANDLED_REJECTION) hostReportErrors('Unhandled promise rejection', reason);
	};

	var onUnhandled = function (promise, state) {
		task$1.call(global_1, function () {
			var value = state.value;
			var IS_UNHANDLED = isUnhandled(state);
			var result;
			if (IS_UNHANDLED) {
				result = perform(function () {
					if (IS_NODE$1) {
						process$3.emit('unhandledRejection', value, promise);
					} else dispatchEvent(UNHANDLED_REJECTION, promise, value);
				});
				// Browsers should not trigger `rejectionHandled` event if it was handled here, NodeJS - should
				state.rejection = IS_NODE$1 || isUnhandled(state) ? UNHANDLED : HANDLED;
				if (result.error) throw result.value;
			}
		});
	};

	var isUnhandled = function (state) {
		return state.rejection !== HANDLED && !state.parent;
	};

	var onHandleUnhandled = function (promise, state) {
		task$1.call(global_1, function () {
			if (IS_NODE$1) {
				process$3.emit('rejectionHandled', promise);
			} else dispatchEvent(REJECTION_HANDLED, promise, state.value);
		});
	};

	var bind = function (fn, promise, state, unwrap) {
		return function (value) {
			fn(promise, state, value, unwrap);
		};
	};

	var internalReject = function (promise, state, value, unwrap) {
		if (state.done) return;
		state.done = true;
		if (unwrap) state = unwrap;
		state.value = value;
		state.state = REJECTED;
		notify$1(promise, state, true);
	};

	var internalResolve = function (promise, state, value, unwrap) {
		if (state.done) return;
		state.done = true;
		if (unwrap) state = unwrap;
		try {
			if (promise === value) throw TypeError$1("Promise can't be resolved itself");
			var then = isThenable(value);
			if (then) {
				microtask(function () {
					var wrapper = { done: false };
					try {
						then.call(value,
							bind(internalResolve, promise, wrapper, state),
							bind(internalReject, promise, wrapper, state)
						);
					} catch (error) {
						internalReject(promise, wrapper, error, state);
					}
				});
			} else {
				state.value = value;
				state.state = FULFILLED;
				notify$1(promise, state, false);
			}
		} catch (error) {
			internalReject(promise, { done: false }, error, state);
		}
	};

	// constructor polyfill
	if (FORCED$1) {
		// 25.4.3.1 Promise(executor)
		PromiseConstructor = function Promise(executor) {
			anInstance(this, PromiseConstructor, PROMISE);
			aFunction$1(executor);
			Internal.call(this);
			var state = getInternalState(this);
			try {
				executor(bind(internalResolve, this, state), bind(internalReject, this, state));
			} catch (error) {
				internalReject(this, state, error);
			}
		};
		// eslint-disable-next-line no-unused-vars
		Internal = function Promise(executor) {
			setInternalState(this, {
				type: PROMISE,
				done: false,
				notified: false,
				parent: false,
				reactions: [],
				rejection: false,
				state: PENDING,
				value: undefined
			});
		};
		Internal.prototype = redefineAll(PromiseConstructor.prototype, {
			// `Promise.prototype.then` method
			// https://tc39.github.io/ecma262/#sec-promise.prototype.then
			then: function then(onFulfilled, onRejected) {
				var state = getInternalPromiseState(this);
				var reaction = newPromiseCapability$1(speciesConstructor(this, PromiseConstructor));
				reaction.ok = typeof onFulfilled == 'function' ? onFulfilled : true;
				reaction.fail = typeof onRejected == 'function' && onRejected;
				reaction.domain = IS_NODE$1 ? process$3.domain : undefined;
				state.parent = true;
				state.reactions.push(reaction);
				if (state.state != PENDING) notify$1(this, state, false);
				return reaction.promise;
			},
			// `Promise.prototype.catch` method
			// https://tc39.github.io/ecma262/#sec-promise.prototype.catch
			'catch': function (onRejected) {
				return this.then(undefined, onRejected);
			}
		});
		OwnPromiseCapability = function () {
			var promise = new Internal();
			var state = getInternalState(promise);
			this.promise = promise;
			this.resolve = bind(internalResolve, promise, state);
			this.reject = bind(internalReject, promise, state);
		};
		newPromiseCapability.f = newPromiseCapability$1 = function (C) {
			return C === PromiseConstructor || C === PromiseWrapper
				? new OwnPromiseCapability(C)
				: newGenericPromiseCapability(C);
		};

		if (typeof nativePromiseConstructor == 'function') {
			nativeThen = nativePromiseConstructor.prototype.then;

			// wrap native Promise#then for native async functions
			redefine(nativePromiseConstructor.prototype, 'then', function then(onFulfilled, onRejected) {
				var that = this;
				return new PromiseConstructor(function (resolve, reject) {
					nativeThen.call(that, resolve, reject);
				}).then(onFulfilled, onRejected);
				// https://github.com/zloirock/core-js/issues/640
			}, { unsafe: true });

			// wrap fetch result
			if (typeof $fetch == 'function') _export({ global: true, enumerable: true, forced: true }, {
				// eslint-disable-next-line no-unused-vars
				fetch: function fetch(input /* , init */) {
					return promiseResolve(PromiseConstructor, $fetch.apply(global_1, arguments));
				}
			});
		}
	}

	_export({ global: true, wrap: true, forced: FORCED$1 }, {
		Promise: PromiseConstructor
	});

	setToStringTag(PromiseConstructor, PROMISE, false);
	setSpecies(PROMISE);

	PromiseWrapper = getBuiltIn(PROMISE);

	// statics
	_export({ target: PROMISE, stat: true, forced: FORCED$1 }, {
		// `Promise.reject` method
		// https://tc39.github.io/ecma262/#sec-promise.reject
		reject: function reject(r) {
			var capability = newPromiseCapability$1(this);
			capability.reject.call(undefined, r);
			return capability.promise;
		}
	});

	_export({ target: PROMISE, stat: true, forced: FORCED$1 }, {
		// `Promise.resolve` method
		// https://tc39.github.io/ecma262/#sec-promise.resolve
		resolve: function resolve(x) {
			return promiseResolve(this, x);
		}
	});

	_export({ target: PROMISE, stat: true, forced: INCORRECT_ITERATION }, {
		// `Promise.all` method
		// https://tc39.github.io/ecma262/#sec-promise.all
		all: function all(iterable) {
			var C = this;
			var capability = newPromiseCapability$1(C);
			var resolve = capability.resolve;
			var reject = capability.reject;
			var result = perform(function () {
				var $promiseResolve = aFunction$1(C.resolve);
				var values = [];
				var counter = 0;
				var remaining = 1;
				iterate_1(iterable, function (promise) {
					var index = counter++;
					var alreadyCalled = false;
					values.push(undefined);
					remaining++;
					$promiseResolve.call(C, promise).then(function (value) {
						if (alreadyCalled) return;
						alreadyCalled = true;
						values[index] = value;
						--remaining || resolve(values);
					}, reject);
				});
				--remaining || resolve(values);
			});
			if (result.error) reject(result.value);
			return capability.promise;
		},
		// `Promise.race` method
		// https://tc39.github.io/ecma262/#sec-promise.race
		race: function race(iterable) {
			var C = this;
			var capability = newPromiseCapability$1(C);
			var reject = capability.reject;
			var result = perform(function () {
				var $promiseResolve = aFunction$1(C.resolve);
				iterate_1(iterable, function (promise) {
					$promiseResolve.call(C, promise).then(capability.resolve, reject);
				});
			});
			if (result.error) reject(result.value);
			return capability.promise;
		}
	});

	// `RegExp.prototype.flags` getter implementation
	// https://tc39.github.io/ecma262/#sec-get-regexp.prototype.flags
	var regexpFlags = function () {
		var that = anObject(this);
		var result = '';
		if (that.global) result += 'g';
		if (that.ignoreCase) result += 'i';
		if (that.multiline) result += 'm';
		if (that.dotAll) result += 's';
		if (that.unicode) result += 'u';
		if (that.sticky) result += 'y';
		return result;
	};

	// babel-minify transpiles RegExp('a', 'y') -> /a/y and it causes SyntaxError,
	// so we use an intermediate function.
	function RE(s, f) {
		return RegExp(s, f);
	}

	var UNSUPPORTED_Y = fails(function () {
		// babel-minify transpiles RegExp('a', 'y') -> /a/y and it causes SyntaxError
		var re = RE('a', 'y');
		re.lastIndex = 2;
		return re.exec('abcd') != null;
	});

	var BROKEN_CARET = fails(function () {
		// https://bugzilla.mozilla.org/show_bug.cgi?id=773687
		var re = RE('^r', 'gy');
		re.lastIndex = 2;
		return re.exec('str') != null;
	});

	var regexpStickyHelpers = {
		UNSUPPORTED_Y: UNSUPPORTED_Y,
		BROKEN_CARET: BROKEN_CARET
	};

	var nativeExec = RegExp.prototype.exec;
	// This always refers to the native implementation, because the
	// String#replace polyfill uses ./fix-regexp-well-known-symbol-logic.js,
	// which loads this file before patching the method.
	var nativeReplace = String.prototype.replace;

	var patchedExec = nativeExec;

	var UPDATES_LAST_INDEX_WRONG = (function () {
		var re1 = /a/;
		var re2 = /b*/g;
		nativeExec.call(re1, 'a');
		nativeExec.call(re2, 'a');
		return re1.lastIndex !== 0 || re2.lastIndex !== 0;
	})();

	var UNSUPPORTED_Y$1 = regexpStickyHelpers.UNSUPPORTED_Y || regexpStickyHelpers.BROKEN_CARET;

	// nonparticipating capturing group, copied from es5-shim's String#split patch.
	var NPCG_INCLUDED = /()??/.exec('')[1] !== undefined;

	var PATCH = UPDATES_LAST_INDEX_WRONG || NPCG_INCLUDED || UNSUPPORTED_Y$1;

	if (PATCH) {
		patchedExec = function exec(str) {
			var re = this;
			var lastIndex, reCopy, match, i;
			var sticky = UNSUPPORTED_Y$1 && re.sticky;
			var flags = regexpFlags.call(re);
			var source = re.source;
			var charsAdded = 0;
			var strCopy = str;

			if (sticky) {
				flags = flags.replace('y', '');
				if (flags.indexOf('g') === -1) {
					flags += 'g';
				}

				strCopy = String(str).slice(re.lastIndex);
				// Support anchored sticky behavior.
				if (re.lastIndex > 0 && (!re.multiline || re.multiline && str[re.lastIndex - 1] !== '\n')) {
					source = '(?: ' + source + ')';
					strCopy = ' ' + strCopy;
					charsAdded++;
				}
				// ^(? + rx + ) is needed, in combination with some str slicing, to
				// simulate the 'y' flag.
				reCopy = new RegExp('^(?:' + source + ')', flags);
			}

			if (NPCG_INCLUDED) {
				reCopy = new RegExp('^' + source + '$(?!\\s)', flags);
			}
			if (UPDATES_LAST_INDEX_WRONG) lastIndex = re.lastIndex;

			match = nativeExec.call(sticky ? reCopy : re, strCopy);

			if (sticky) {
				if (match) {
					match.input = match.input.slice(charsAdded);
					match[0] = match[0].slice(charsAdded);
					match.index = re.lastIndex;
					re.lastIndex += match[0].length;
				} else re.lastIndex = 0;
			} else if (UPDATES_LAST_INDEX_WRONG && match) {
				re.lastIndex = re.global ? match.index + match[0].length : lastIndex;
			}
			if (NPCG_INCLUDED && match && match.length > 1) {
				// Fix browsers whose `exec` methods don't consistently return `undefined`
				// for NPCG, like IE8. NOTE: This doesn' work for /(.?)?/
				nativeReplace.call(match[0], reCopy, function () {
					for (i = 1; i < arguments.length - 2; i++) {
						if (arguments[i] === undefined) match[i] = undefined;
					}
				});
			}

			return match;
		};
	}

	var regexpExec = patchedExec;

	_export({ target: 'RegExp', proto: true, forced: /./.exec !== regexpExec }, {
		exec: regexpExec
	});

	var TO_STRING = 'toString';
	var RegExpPrototype = RegExp.prototype;
	var nativeToString = RegExpPrototype[TO_STRING];

	var NOT_GENERIC = fails(function () { return nativeToString.call({ source: 'a', flags: 'b' }) != '/a/b'; });
	// FF44- RegExp#toString has a wrong name
	var INCORRECT_NAME = nativeToString.name != TO_STRING;

	// `RegExp.prototype.toString` method
	// https://tc39.github.io/ecma262/#sec-regexp.prototype.tostring
	if (NOT_GENERIC || INCORRECT_NAME) {
		redefine(RegExp.prototype, TO_STRING, function toString() {
			var R = anObject(this);
			var p = String(R.source);
			var rf = R.flags;
			var f = String(rf === undefined && R instanceof RegExp && !('flags' in RegExpPrototype) ? regexpFlags.call(R) : rf);
			return '/' + p + '/' + f;
		}, { unsafe: true });
	}

	// TODO: Remove from `core-js@4` since it's moved to entry points







	var SPECIES$6 = wellKnownSymbol('species');

	var REPLACE_SUPPORTS_NAMED_GROUPS = !fails(function () {
		// #replace needs built-in support for named groups.
		// #match works fine because it just return the exec results, even if it has
		// a "grops" property.
		var re = /./;
		re.exec = function () {
			var result = [];
			result.groups = { a: '7' };
			return result;
		};
		return ''.replace(re, '$<a>') !== '7';
	});

	// IE <= 11 replaces $0 with the whole match, as if it was $&
	// https://stackoverflow.com/questions/6024666/getting-ie-to-replace-a-regex-with-the-literal-string-0
	var REPLACE_KEEPS_$0 = (function () {
		return 'a'.replace(/./, '$0') === '$0';
	})();

	var REPLACE = wellKnownSymbol('replace');
	// Safari <= 13.0.3(?) substitutes nth capture where n>m with an empty string
	var REGEXP_REPLACE_SUBSTITUTES_UNDEFINED_CAPTURE = (function () {
		if (/./[REPLACE]) {
			return /./[REPLACE]('a', '$0') === '';
		}
		return false;
	})();

	// Chrome 51 has a buggy "split" implementation when RegExp#exec !== nativeExec
	// Weex JS has frozen built-in prototypes, so use try / catch wrapper
	var SPLIT_WORKS_WITH_OVERWRITTEN_EXEC = !fails(function () {
		var re = /(?:)/;
		var originalExec = re.exec;
		re.exec = function () { return originalExec.apply(this, arguments); };
		var result = 'ab'.split(re);
		return result.length !== 2 || result[0] !== 'a' || result[1] !== 'b';
	});

	var fixRegexpWellKnownSymbolLogic = function (KEY, length, exec, sham) {
		var SYMBOL = wellKnownSymbol(KEY);

		var DELEGATES_TO_SYMBOL = !fails(function () {
			// String methods call symbol-named RegEp methods
			var O = {};
			O[SYMBOL] = function () { return 7; };
			return ''[KEY](O) != 7;
		});

		var DELEGATES_TO_EXEC = DELEGATES_TO_SYMBOL && !fails(function () {
			// Symbol-named RegExp methods call .exec
			var execCalled = false;
			var re = /a/;

			if (KEY === 'split') {
				// We can't use real regex here since it causes deoptimization
				// and serious performance degradation in V8
				// https://github.com/zloirock/core-js/issues/306
				re = {};
				// RegExp[@@split] doesn't call the regex's exec method, but first creates
				// a new one. We need to return the patched regex when creating the new one.
				re.constructor = {};
				re.constructor[SPECIES$6] = function () { return re; };
				re.flags = '';
				re[SYMBOL] = /./[SYMBOL];
			}

			re.exec = function () { execCalled = true; return null; };

			re[SYMBOL]('');
			return !execCalled;
		});

		if (
			!DELEGATES_TO_SYMBOL ||
			!DELEGATES_TO_EXEC ||
			(KEY === 'replace' && !(
				REPLACE_SUPPORTS_NAMED_GROUPS &&
				REPLACE_KEEPS_$0 &&
				!REGEXP_REPLACE_SUBSTITUTES_UNDEFINED_CAPTURE
			)) ||
			(KEY === 'split' && !SPLIT_WORKS_WITH_OVERWRITTEN_EXEC)
		) {
			var nativeRegExpMethod = /./[SYMBOL];
			var methods = exec(SYMBOL, ''[KEY], function (nativeMethod, regexp, str, arg2, forceStringMethod) {
				if (regexp.exec === regexpExec) {
					if (DELEGATES_TO_SYMBOL && !forceStringMethod) {
						// The native String method already delegates to @@method (this
						// polyfilled function), leasing to infinite recursion.
						// We avoid it by directly calling the native @@method method.
						return { done: true, value: nativeRegExpMethod.call(regexp, str, arg2) };
					}
					return { done: true, value: nativeMethod.call(str, regexp, arg2) };
				}
				return { done: false };
			}, {
				REPLACE_KEEPS_$0: REPLACE_KEEPS_$0,
				REGEXP_REPLACE_SUBSTITUTES_UNDEFINED_CAPTURE: REGEXP_REPLACE_SUBSTITUTES_UNDEFINED_CAPTURE
			});
			var stringMethod = methods[0];
			var regexMethod = methods[1];

			redefine(String.prototype, KEY, stringMethod);
			redefine(RegExp.prototype, SYMBOL, length == 2
				// 21.2.5.8 RegExp.prototype[@@replace](string, replaceValue)
				// 21.2.5.11 RegExp.prototype[@@split](string, limit)
				? function (string, arg) { return regexMethod.call(string, this, arg); }
				// 21.2.5.6 RegExp.prototype[@@match](string)
				// 21.2.5.9 RegExp.prototype[@@search](string)
				: function (string) { return regexMethod.call(string, this); }
			);
		}

		if (sham) createNonEnumerableProperty(RegExp.prototype[SYMBOL], 'sham', true);
	};

	var MATCH = wellKnownSymbol('match');

	// `IsRegExp` abstract operation
	// https://tc39.github.io/ecma262/#sec-isregexp
	var isRegexp = function (it) {
		var isRegExp;
		return isObject(it) && ((isRegExp = it[MATCH]) !== undefined ? !!isRegExp : classofRaw(it) == 'RegExp');
	};

	// `String.prototype.{ codePointAt, at }` methods implementation
	var createMethod$2 = function (CONVERT_TO_STRING) {
		return function ($this, pos) {
			var S = String(requireObjectCoercible($this));
			var position = toInteger(pos);
			var size = S.length;
			var first, second;
			if (position < 0 || position >= size) return CONVERT_TO_STRING ? '' : undefined;
			first = S.charCodeAt(position);
			return first < 0xD800 || first > 0xDBFF || position + 1 === size
				|| (second = S.charCodeAt(position + 1)) < 0xDC00 || second > 0xDFFF
				? CONVERT_TO_STRING ? S.charAt(position) : first
				: CONVERT_TO_STRING ? S.slice(position, position + 2) : (first - 0xD800 << 10) + (second - 0xDC00) + 0x10000;
		};
	};

	var stringMultibyte = {
		// `String.prototype.codePointAt` method
		// https://tc39.github.io/ecma262/#sec-string.prototype.codepointat
		codeAt: createMethod$2(false),
		// `String.prototype.at` method
		// https://github.com/mathiasbynens/String.prototype.at
		charAt: createMethod$2(true)
	};

	var charAt = stringMultibyte.charAt;

	// `AdvanceStringIndex` abstract operation
	// https://tc39.github.io/ecma262/#sec-advancestringindex
	var advanceStringIndex = function (S, index, unicode) {
		return index + (unicode ? charAt(S, index).length : 1);
	};

	// `RegExpExec` abstract operation
	// https://tc39.github.io/ecma262/#sec-regexpexec
	var regexpExecAbstract = function (R, S) {
		var exec = R.exec;
		if (typeof exec === 'function') {
			var result = exec.call(R, S);
			if (typeof result !== 'object') {
				throw TypeError('RegExp exec method returned something other than an Object or null');
			}
			return result;
		}

		if (classofRaw(R) !== 'RegExp') {
			throw TypeError('RegExp#exec called on incompatible receiver');
		}

		return regexpExec.call(R, S);
	};

	var arrayPush = [].push;
	var min$3 = Math.min;
	var MAX_UINT32 = 0xFFFFFFFF;

	// babel-minify transpiles RegExp('x', 'y') -> /x/y and it causes SyntaxError
	var SUPPORTS_Y = !fails(function () { return !RegExp(MAX_UINT32, 'y'); });

	// @@split logic
	fixRegexpWellKnownSymbolLogic('split', 2, function (SPLIT, nativeSplit, maybeCallNative) {
		var internalSplit;
		if (
			'abbc'.split(/(b)*/)[1] == 'c' ||
			'test'.split(/(?:)/, -1).length != 4 ||
			'ab'.split(/(?:ab)*/).length != 2 ||
			'.'.split(/(.?)(.?)/).length != 4 ||
			'.'.split(/()()/).length > 1 ||
			''.split(/.?/).length
		) {
			// based on es5-shim implementation, need to rework it
			internalSplit = function (separator, limit) {
				var string = String(requireObjectCoercible(this));
				var lim = limit === undefined ? MAX_UINT32 : limit >>> 0;
				if (lim === 0) return [];
				if (separator === undefined) return [string];
				// If `separator` is not a regex, use native split
				if (!isRegexp(separator)) {
					return nativeSplit.call(string, separator, lim);
				}
				var output = [];
				var flags = (separator.ignoreCase ? 'i' : '') +
					(separator.multiline ? 'm' : '') +
					(separator.unicode ? 'u' : '') +
					(separator.sticky ? 'y' : '');
				var lastLastIndex = 0;
				// Make `global` and avoid `lastIndex` issues by working with a copy
				var separatorCopy = new RegExp(separator.source, flags + 'g');
				var match, lastIndex, lastLength;
				while (match = regexpExec.call(separatorCopy, string)) {
					lastIndex = separatorCopy.lastIndex;
					if (lastIndex > lastLastIndex) {
						output.push(string.slice(lastLastIndex, match.index));
						if (match.length > 1 && match.index < string.length) arrayPush.apply(output, match.slice(1));
						lastLength = match[0].length;
						lastLastIndex = lastIndex;
						if (output.length >= lim) break;
					}
					if (separatorCopy.lastIndex === match.index) separatorCopy.lastIndex++; // Avoid an infinite loop
				}
				if (lastLastIndex === string.length) {
					if (lastLength || !separatorCopy.test('')) output.push('');
				} else output.push(string.slice(lastLastIndex));
				return output.length > lim ? output.slice(0, lim) : output;
			};
			// Chakra, V8
		} else if ('0'.split(undefined, 0).length) {
			internalSplit = function (separator, limit) {
				return separator === undefined && limit === 0 ? [] : nativeSplit.call(this, separator, limit);
			};
		} else internalSplit = nativeSplit;

		return [
			// `String.prototype.split` method
			// https://tc39.github.io/ecma262/#sec-string.prototype.split
			function split(separator, limit) {
				var O = requireObjectCoercible(this);
				var splitter = separator == undefined ? undefined : separator[SPLIT];
				return splitter !== undefined
					? splitter.call(separator, O, limit)
					: internalSplit.call(String(O), separator, limit);
			},
			// `RegExp.prototype[@@split]` method
			// https://tc39.github.io/ecma262/#sec-regexp.prototype-@@split
			//
			// NOTE: This cannot be properly polyfilled in engines that don't support
			// the 'y' flag.
			function (regexp, limit) {
				var res = maybeCallNative(internalSplit, regexp, this, limit, internalSplit !== nativeSplit);
				if (res.done) return res.value;

				var rx = anObject(regexp);
				var S = String(this);
				var C = speciesConstructor(rx, RegExp);

				var unicodeMatching = rx.unicode;
				var flags = (rx.ignoreCase ? 'i' : '') +
					(rx.multiline ? 'm' : '') +
					(rx.unicode ? 'u' : '') +
					(SUPPORTS_Y ? 'y' : 'g');

				// ^(? + rx + ) is needed, in combination with some S slicing, to
				// simulate the 'y' flag.
				var splitter = new C(SUPPORTS_Y ? rx : '^(?:' + rx.source + ')', flags);
				var lim = limit === undefined ? MAX_UINT32 : limit >>> 0;
				if (lim === 0) return [];
				if (S.length === 0) return regexpExecAbstract(splitter, S) === null ? [S] : [];
				var p = 0;
				var q = 0;
				var A = [];
				while (q < S.length) {
					splitter.lastIndex = SUPPORTS_Y ? q : 0;
					var z = regexpExecAbstract(splitter, SUPPORTS_Y ? S : S.slice(q));
					var e;
					if (
						z === null ||
						(e = min$3(toLength(splitter.lastIndex + (SUPPORTS_Y ? 0 : q)), S.length)) === p
					) {
						q = advanceStringIndex(S, q, unicodeMatching);
					} else {
						A.push(S.slice(p, q));
						if (A.length === lim) return A;
						for (var i = 1; i <= z.length - 1; i++) {
							A.push(z[i]);
							if (A.length === lim) return A;
						}
						q = p = e;
					}
				}
				A.push(S.slice(p));
				return A;
			}
		];
	}, !SUPPORTS_Y);

	// iterable DOM collections
	// flag - `iterable` interface - 'entries', 'keys', 'values', 'forEach' methods
	var domIterables = {
		CSSRuleList: 0,
		CSSStyleDeclaration: 0,
		CSSValueList: 0,
		ClientRectList: 0,
		DOMRectList: 0,
		DOMStringList: 0,
		DOMTokenList: 1,
		DataTransferItemList: 0,
		FileList: 0,
		HTMLAllCollection: 0,
		HTMLCollection: 0,
		HTMLFormElement: 0,
		HTMLSelectElement: 0,
		MediaList: 0,
		MimeTypeArray: 0,
		NamedNodeMap: 0,
		NodeList: 1,
		PaintRequestList: 0,
		Plugin: 0,
		PluginArray: 0,
		SVGLengthList: 0,
		SVGNumberList: 0,
		SVGPathSegList: 0,
		SVGPointList: 0,
		SVGStringList: 0,
		SVGTransformList: 0,
		SourceBufferList: 0,
		StyleSheetList: 0,
		TextTrackCueList: 0,
		TextTrackList: 0,
		TouchList: 0
	};

	for (var COLLECTION_NAME in domIterables) {
		var Collection = global_1[COLLECTION_NAME];
		var CollectionPrototype = Collection && Collection.prototype;
		// some Chrome versions have non-configurable methods on DOMTokenList
		if (CollectionPrototype && CollectionPrototype.forEach !== arrayForEach) try {
			createNonEnumerableProperty(CollectionPrototype, 'forEach', arrayForEach);
		} catch (error) {
			CollectionPrototype.forEach = arrayForEach;
		}
	}

	var runtime_1 = createCommonjsModule(function (module) {
		/**
		 * Copyright (c) 2014-present, Facebook, Inc.
		 *
		 * This source code is licensed under the MIT license found in the
		 * LICENSE file in the root directory of this source tree.
		 */

		var runtime = (function (exports) {

			var Op = Object.prototype;
			var hasOwn = Op.hasOwnProperty;
			var undefined$1; // More compressible than void 0.
			var $Symbol = typeof Symbol === "function" ? Symbol : {};
			var iteratorSymbol = $Symbol.iterator || "@@iterator";
			var asyncIteratorSymbol = $Symbol.asyncIterator || "@@asyncIterator";
			var toStringTagSymbol = $Symbol.toStringTag || "@@toStringTag";

			function define(obj, key, value) {
				Object.defineProperty(obj, key, {
					value: value,
					enumerable: true,
					configurable: true,
					writable: true
				});
				return obj[key];
			}
			try {
				// IE 8 has a broken Object.defineProperty that only works on DOM objects.
				define({}, "");
			} catch (err) {
				define = function (obj, key, value) {
					return obj[key] = value;
				};
			}

			function wrap(innerFn, outerFn, self, tryLocsList) {
				// If outerFn provided and outerFn.prototype is a Generator, then outerFn.prototype instanceof Generator.
				var protoGenerator = outerFn && outerFn.prototype instanceof Generator ? outerFn : Generator;
				var generator = Object.create(protoGenerator.prototype);
				var context = new Context(tryLocsList || []);

				// The ._invoke method unifies the implementations of the .next,
				// .throw, and .return methods.
				generator._invoke = makeInvokeMethod(innerFn, self, context);

				return generator;
			}
			exports.wrap = wrap;

			// Try/catch helper to minimize deoptimizations. Returns a completion
			// record like context.tryEntries[i].completion. This interface could
			// have been (and was previously) designed to take a closure to be
			// invoked without arguments, but in all the cases we care about we
			// already have an existing method we want to call, so there's no need
			// to create a new function object. We can even get away with assuming
			// the method takes exactly one argument, since that happens to be true
			// in every case, so we don't have to touch the arguments object. The
			// only additional allocation required is the completion record, which
			// has a stable shape and so hopefully should be cheap to allocate.
			function tryCatch(fn, obj, arg) {
				try {
					return { type: "normal", arg: fn.call(obj, arg) };
				} catch (err) {
					return { type: "throw", arg: err };
				}
			}

			var GenStateSuspendedStart = "suspendedStart";
			var GenStateSuspendedYield = "suspendedYield";
			var GenStateExecuting = "executing";
			var GenStateCompleted = "completed";

			// Returning this object from the innerFn has the same effect as
			// breaking out of the dispatch switch statement.
			var ContinueSentinel = {};

			// Dummy constructor functions that we use as the .constructor and
			// .constructor.prototype properties for functions that return Generator
			// objects. For full spec compliance, you may wish to configure your
			// minifier not to mangle the names of these two functions.
			function Generator() { }
			function GeneratorFunction() { }
			function GeneratorFunctionPrototype() { }

			// This is a polyfill for %IteratorPrototype% for environments that
			// don't natively support it.
			var IteratorPrototype = {};
			IteratorPrototype[iteratorSymbol] = function () {
				return this;
			};

			var getProto = Object.getPrototypeOf;
			var NativeIteratorPrototype = getProto && getProto(getProto(values([])));
			if (NativeIteratorPrototype &&
				NativeIteratorPrototype !== Op &&
				hasOwn.call(NativeIteratorPrototype, iteratorSymbol)) {
				// This environment has a native %IteratorPrototype%; use it instead
				// of the polyfill.
				IteratorPrototype = NativeIteratorPrototype;
			}

			var Gp = GeneratorFunctionPrototype.prototype =
				Generator.prototype = Object.create(IteratorPrototype);
			GeneratorFunction.prototype = Gp.constructor = GeneratorFunctionPrototype;
			GeneratorFunctionPrototype.constructor = GeneratorFunction;
			GeneratorFunction.displayName = define(
				GeneratorFunctionPrototype,
				toStringTagSymbol,
				"GeneratorFunction"
			);

			// Helper for defining the .next, .throw, and .return methods of the
			// Iterator interface in terms of a single ._invoke method.
			function defineIteratorMethods(prototype) {
				["next", "throw", "return"].forEach(function (method) {
					define(prototype, method, function (arg) {
						return this._invoke(method, arg);
					});
				});
			}

			exports.isGeneratorFunction = function (genFun) {
				var ctor = typeof genFun === "function" && genFun.constructor;
				return ctor
					? ctor === GeneratorFunction ||
					// For the native GeneratorFunction constructor, the best we can
					// do is to check its .name property.
					(ctor.displayName || ctor.name) === "GeneratorFunction"
					: false;
			};

			exports.mark = function (genFun) {
				if (Object.setPrototypeOf) {
					Object.setPrototypeOf(genFun, GeneratorFunctionPrototype);
				} else {
					genFun.__proto__ = GeneratorFunctionPrototype;
					define(genFun, toStringTagSymbol, "GeneratorFunction");
				}
				genFun.prototype = Object.create(Gp);
				return genFun;
			};

			// Within the body of any async function, `await x` is transformed to
			// `yield regeneratorRuntime.awrap(x)`, so that the runtime can test
			// `hasOwn.call(value, "__await")` to determine if the yielded value is
			// meant to be awaited.
			exports.awrap = function (arg) {
				return { __await: arg };
			};

			function AsyncIterator(generator, PromiseImpl) {
				function invoke(method, arg, resolve, reject) {
					var record = tryCatch(generator[method], generator, arg);
					if (record.type === "throw") {
						reject(record.arg);
					} else {
						var result = record.arg;
						var value = result.value;
						if (value &&
							typeof value === "object" &&
							hasOwn.call(value, "__await")) {
							return PromiseImpl.resolve(value.__await).then(function (value) {
								invoke("next", value, resolve, reject);
							}, function (err) {
								invoke("throw", err, resolve, reject);
							});
						}

						return PromiseImpl.resolve(value).then(function (unwrapped) {
							// When a yielded Promise is resolved, its final value becomes
							// the .value of the Promise<{value,done}> result for the
							// current iteration.
							result.value = unwrapped;
							resolve(result);
						}, function (error) {
							// If a rejected Promise was yielded, throw the rejection back
							// into the async generator function so it can be handled there.
							return invoke("throw", error, resolve, reject);
						});
					}
				}

				var previousPromise;

				function enqueue(method, arg) {
					function callInvokeWithMethodAndArg() {
						return new PromiseImpl(function (resolve, reject) {
							invoke(method, arg, resolve, reject);
						});
					}

					return previousPromise =
						// If enqueue has been called before, then we want to wait until
						// all previous Promises have been resolved before calling invoke,
						// so that results are always delivered in the correct order. If
						// enqueue has not been called before, then it is important to
						// call invoke immediately, without waiting on a callback to fire,
						// so that the async generator function has the opportunity to do
						// any necessary setup in a predictable way. This predictability
						// is why the Promise constructor synchronously invokes its
						// executor callback, and why async functions synchronously
						// execute code before the first await. Since we implement simple
						// async functions in terms of async generators, it is especially
						// important to get this right, even though it requires care.
						previousPromise ? previousPromise.then(
							callInvokeWithMethodAndArg,
							// Avoid propagating failures to Promises returned by later
							// invocations of the iterator.
							callInvokeWithMethodAndArg
						) : callInvokeWithMethodAndArg();
				}

				// Define the unified helper method that is used to implement .next,
				// .throw, and .return (see defineIteratorMethods).
				this._invoke = enqueue;
			}

			defineIteratorMethods(AsyncIterator.prototype);
			AsyncIterator.prototype[asyncIteratorSymbol] = function () {
				return this;
			};
			exports.AsyncIterator = AsyncIterator;

			// Note that simple async functions are implemented on top of
			// AsyncIterator objects; they just return a Promise for the value of
			// the final result produced by the iterator.
			exports.async = function (innerFn, outerFn, self, tryLocsList, PromiseImpl) {
				if (PromiseImpl === void 0) PromiseImpl = Promise;

				var iter = new AsyncIterator(
					wrap(innerFn, outerFn, self, tryLocsList),
					PromiseImpl
				);

				return exports.isGeneratorFunction(outerFn)
					? iter // If outerFn is a generator, return the full iterator.
					: iter.next().then(function (result) {
						return result.done ? result.value : iter.next();
					});
			};

			function makeInvokeMethod(innerFn, self, context) {
				var state = GenStateSuspendedStart;

				return function invoke(method, arg) {
					if (state === GenStateExecuting) {
						throw new Error("Generator is already running");
					}

					if (state === GenStateCompleted) {
						if (method === "throw") {
							throw arg;
						}

						// Be forgiving, per 25.3.3.3.3 of the spec:
						// https://people.mozilla.org/~jorendorff/es6-draft.html#sec-generatorresume
						return doneResult();
					}

					context.method = method;
					context.arg = arg;

					while (true) {
						var delegate = context.delegate;
						if (delegate) {
							var delegateResult = maybeInvokeDelegate(delegate, context);
							if (delegateResult) {
								if (delegateResult === ContinueSentinel) continue;
								return delegateResult;
							}
						}

						if (context.method === "next") {
							// Setting context._sent for legacy support of Babel's
							// function.sent implementation.
							context.sent = context._sent = context.arg;

						} else if (context.method === "throw") {
							if (state === GenStateSuspendedStart) {
								state = GenStateCompleted;
								throw context.arg;
							}

							context.dispatchException(context.arg);

						} else if (context.method === "return") {
							context.abrupt("return", context.arg);
						}

						state = GenStateExecuting;

						var record = tryCatch(innerFn, self, context);
						if (record.type === "normal") {
							// If an exception is thrown from innerFn, we leave state ===
							// GenStateExecuting and loop back for another invocation.
							state = context.done
								? GenStateCompleted
								: GenStateSuspendedYield;

							if (record.arg === ContinueSentinel) {
								continue;
							}

							return {
								value: record.arg,
								done: context.done
							};

						} else if (record.type === "throw") {
							state = GenStateCompleted;
							// Dispatch the exception by looping back around to the
							// context.dispatchException(context.arg) call above.
							context.method = "throw";
							context.arg = record.arg;
						}
					}
				};
			}

			// Call delegate.iterator[context.method](context.arg) and handle the
			// result, either by returning a { value, done } result from the
			// delegate iterator, or by modifying context.method and context.arg,
			// setting context.delegate to null, and returning the ContinueSentinel.
			function maybeInvokeDelegate(delegate, context) {
				var method = delegate.iterator[context.method];
				if (method === undefined$1) {
					// A .throw or .return when the delegate iterator has no .throw
					// method always terminates the yield* loop.
					context.delegate = null;

					if (context.method === "throw") {
						// Note: ["return"] must be used for ES3 parsing compatibility.
						if (delegate.iterator["return"]) {
							// If the delegate iterator has a return method, give it a
							// chance to clean up.
							context.method = "return";
							context.arg = undefined$1;
							maybeInvokeDelegate(delegate, context);

							if (context.method === "throw") {
								// If maybeInvokeDelegate(context) changed context.method from
								// "return" to "throw", let that override the TypeError below.
								return ContinueSentinel;
							}
						}

						context.method = "throw";
						context.arg = new TypeError(
							"The iterator does not provide a 'throw' method");
					}

					return ContinueSentinel;
				}

				var record = tryCatch(method, delegate.iterator, context.arg);

				if (record.type === "throw") {
					context.method = "throw";
					context.arg = record.arg;
					context.delegate = null;
					return ContinueSentinel;
				}

				var info = record.arg;

				if (!info) {
					context.method = "throw";
					context.arg = new TypeError("iterator result is not an object");
					context.delegate = null;
					return ContinueSentinel;
				}

				if (info.done) {
					// Assign the result of the finished delegate to the temporary
					// variable specified by delegate.resultName (see delegateYield).
					context[delegate.resultName] = info.value;

					// Resume execution at the desired location (see delegateYield).
					context.next = delegate.nextLoc;

					// If context.method was "throw" but the delegate handled the
					// exception, let the outer generator proceed normally. If
					// context.method was "next", forget context.arg since it has been
					// "consumed" by the delegate iterator. If context.method was
					// "return", allow the original .return call to continue in the
					// outer generator.
					if (context.method !== "return") {
						context.method = "next";
						context.arg = undefined$1;
					}

				} else {
					// Re-yield the result returned by the delegate method.
					return info;
				}

				// The delegate iterator is finished, so forget it and continue with
				// the outer generator.
				context.delegate = null;
				return ContinueSentinel;
			}

			// Define Generator.prototype.{next,throw,return} in terms of the
			// unified ._invoke helper method.
			defineIteratorMethods(Gp);

			define(Gp, toStringTagSymbol, "Generator");

			// A Generator should always return itself as the iterator object when the
			// @@iterator function is called on it. Some browsers' implementations of the
			// iterator prototype chain incorrectly implement this, causing the Generator
			// object to not be returned from this call. This ensures that doesn't happen.
			// See https://github.com/facebook/regenerator/issues/274 for more details.
			Gp[iteratorSymbol] = function () {
				return this;
			};

			Gp.toString = function () {
				return "[object Generator]";
			};

			function pushTryEntry(locs) {
				var entry = { tryLoc: locs[0] };

				if (1 in locs) {
					entry.catchLoc = locs[1];
				}

				if (2 in locs) {
					entry.finallyLoc = locs[2];
					entry.afterLoc = locs[3];
				}

				this.tryEntries.push(entry);
			}

			function resetTryEntry(entry) {
				var record = entry.completion || {};
				record.type = "normal";
				delete record.arg;
				entry.completion = record;
			}

			function Context(tryLocsList) {
				// The root entry object (effectively a try statement without a catch
				// or a finally block) gives us a place to store values thrown from
				// locations where there is no enclosing try statement.
				this.tryEntries = [{ tryLoc: "root" }];
				tryLocsList.forEach(pushTryEntry, this);
				this.reset(true);
			}

			exports.keys = function (object) {
				var keys = [];
				for (var key in object) {
					keys.push(key);
				}
				keys.reverse();

				// Rather than returning an object with a next method, we keep
				// things simple and return the next function itself.
				return function next() {
					while (keys.length) {
						var key = keys.pop();
						if (key in object) {
							next.value = key;
							next.done = false;
							return next;
						}
					}

					// To avoid creating an additional object, we just hang the .value
					// and .done properties off the next function object itself. This
					// also ensures that the minifier will not anonymize the function.
					next.done = true;
					return next;
				};
			};

			function values(iterable) {
				if (iterable) {
					var iteratorMethod = iterable[iteratorSymbol];
					if (iteratorMethod) {
						return iteratorMethod.call(iterable);
					}

					if (typeof iterable.next === "function") {
						return iterable;
					}

					if (!isNaN(iterable.length)) {
						var i = -1, next = function next() {
							while (++i < iterable.length) {
								if (hasOwn.call(iterable, i)) {
									next.value = iterable[i];
									next.done = false;
									return next;
								}
							}

							next.value = undefined$1;
							next.done = true;

							return next;
						};

						return next.next = next;
					}
				}

				// Return an iterator with no values.
				return { next: doneResult };
			}
			exports.values = values;

			function doneResult() {
				return { value: undefined$1, done: true };
			}

			Context.prototype = {
				constructor: Context,

				reset: function (skipTempReset) {
					this.prev = 0;
					this.next = 0;
					// Resetting context._sent for legacy support of Babel's
					// function.sent implementation.
					this.sent = this._sent = undefined$1;
					this.done = false;
					this.delegate = null;

					this.method = "next";
					this.arg = undefined$1;

					this.tryEntries.forEach(resetTryEntry);

					if (!skipTempReset) {
						for (var name in this) {
							// Not sure about the optimal order of these conditions:
							if (name.charAt(0) === "t" &&
								hasOwn.call(this, name) &&
								!isNaN(+name.slice(1))) {
								this[name] = undefined$1;
							}
						}
					}
				},

				stop: function () {
					this.done = true;

					var rootEntry = this.tryEntries[0];
					var rootRecord = rootEntry.completion;
					if (rootRecord.type === "throw") {
						throw rootRecord.arg;
					}

					return this.rval;
				},

				dispatchException: function (exception) {
					if (this.done) {
						throw exception;
					}

					var context = this;
					function handle(loc, caught) {
						record.type = "throw";
						record.arg = exception;
						context.next = loc;

						if (caught) {
							// If the dispatched exception was caught by a catch block,
							// then let that catch block handle the exception normally.
							context.method = "next";
							context.arg = undefined$1;
						}

						return !!caught;
					}

					for (var i = this.tryEntries.length - 1; i >= 0; --i) {
						var entry = this.tryEntries[i];
						var record = entry.completion;

						if (entry.tryLoc === "root") {
							// Exception thrown outside of any try block that could handle
							// it, so set the completion value of the entire function to
							// throw the exception.
							return handle("end");
						}

						if (entry.tryLoc <= this.prev) {
							var hasCatch = hasOwn.call(entry, "catchLoc");
							var hasFinally = hasOwn.call(entry, "finallyLoc");

							if (hasCatch && hasFinally) {
								if (this.prev < entry.catchLoc) {
									return handle(entry.catchLoc, true);
								} else if (this.prev < entry.finallyLoc) {
									return handle(entry.finallyLoc);
								}

							} else if (hasCatch) {
								if (this.prev < entry.catchLoc) {
									return handle(entry.catchLoc, true);
								}

							} else if (hasFinally) {
								if (this.prev < entry.finallyLoc) {
									return handle(entry.finallyLoc);
								}

							} else {
								throw new Error("try statement without catch or finally");
							}
						}
					}
				},

				abrupt: function (type, arg) {
					for (var i = this.tryEntries.length - 1; i >= 0; --i) {
						var entry = this.tryEntries[i];
						if (entry.tryLoc <= this.prev &&
							hasOwn.call(entry, "finallyLoc") &&
							this.prev < entry.finallyLoc) {
							var finallyEntry = entry;
							break;
						}
					}

					if (finallyEntry &&
						(type === "break" ||
							type === "continue") &&
						finallyEntry.tryLoc <= arg &&
						arg <= finallyEntry.finallyLoc) {
						// Ignore the finally entry if control is not jumping to a
						// location outside the try/catch block.
						finallyEntry = null;
					}

					var record = finallyEntry ? finallyEntry.completion : {};
					record.type = type;
					record.arg = arg;

					if (finallyEntry) {
						this.method = "next";
						this.next = finallyEntry.finallyLoc;
						return ContinueSentinel;
					}

					return this.complete(record);
				},

				complete: function (record, afterLoc) {
					if (record.type === "throw") {
						throw record.arg;
					}

					if (record.type === "break" ||
						record.type === "continue") {
						this.next = record.arg;
					} else if (record.type === "return") {
						this.rval = this.arg = record.arg;
						this.method = "return";
						this.next = "end";
					} else if (record.type === "normal" && afterLoc) {
						this.next = afterLoc;
					}

					return ContinueSentinel;
				},

				finish: function (finallyLoc) {
					for (var i = this.tryEntries.length - 1; i >= 0; --i) {
						var entry = this.tryEntries[i];
						if (entry.finallyLoc === finallyLoc) {
							this.complete(entry.completion, entry.afterLoc);
							resetTryEntry(entry);
							return ContinueSentinel;
						}
					}
				},

				"catch": function (tryLoc) {
					for (var i = this.tryEntries.length - 1; i >= 0; --i) {
						var entry = this.tryEntries[i];
						if (entry.tryLoc === tryLoc) {
							var record = entry.completion;
							if (record.type === "throw") {
								var thrown = record.arg;
								resetTryEntry(entry);
							}
							return thrown;
						}
					}

					// The context.catch method must only be called with a location
					// argument that corresponds to a known catch block.
					throw new Error("illegal catch attempt");
				},

				delegateYield: function (iterable, resultName, nextLoc) {
					this.delegate = {
						iterator: values(iterable),
						resultName: resultName,
						nextLoc: nextLoc
					};

					if (this.method === "next") {
						// Deliberately forget the last sent value so that we don't
						// accidentally pass it on to the delegate.
						this.arg = undefined$1;
					}

					return ContinueSentinel;
				}
			};

			// Regardless of whether this script is executing as a CommonJS module
			// or not, return the runtime object so that we can declare the variable
			// regeneratorRuntime in the outer scope, which allows this module to be
			// injected easily by `bin/regenerator --include-runtime script.js`.
			return exports;

		}(
			// If this script is executing as a CommonJS module, use module.exports
			// as the regeneratorRuntime namespace. Otherwise create a new empty
			// object. Either way, the resulting object will be used to initialize
			// the regeneratorRuntime variable at the top of this file.
			module.exports
		));

		try {
			regeneratorRuntime = runtime;
		} catch (accidentalStrictMode) {
			// This module should not be running in strict mode, so the above
			// assignment should always work unless something is misconfigured. Just
			// in case runtime.js accidentally runs in strict mode, we can escape
			// strict mode using a global Function call. This could conceivably fail
			// if a Content Security Policy forbids using Function, but in that case
			// the proper solution is to fix the accidental strict mode problem. If
			// you've misconfigured your bundler to force strict mode and applied a
			// CSP to forbid Function, and you're not willing to fix either of those
			// problems, please detail your unique predicament in a GitHub issue.
			Function("r", "regeneratorRuntime = r")(runtime);
		}
	});

	var regenerator = runtime_1;

	function _typeof(obj) {
		"@babel/helpers - typeof";

		if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") {
			_typeof = function (obj) {
				return typeof obj;
			};
		} else {
			_typeof = function (obj) {
				return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj;
			};
		}

		return _typeof(obj);
	}

	function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) {
		try {
			var info = gen[key](arg);
			var value = info.value;
		} catch (error) {
			reject(error);
			return;
		}

		if (info.done) {
			resolve(value);
		} else {
			Promise.resolve(value).then(_next, _throw);
		}
	}

	function _asyncToGenerator(fn) {
		return function () {
			var self = this,
				args = arguments;
			return new Promise(function (resolve, reject) {
				var gen = fn.apply(self, args);

				function _next(value) {
					asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value);
				}

				function _throw(err) {
					asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err);
				}

				_next(undefined);
			});
		};
	}

	function _classCallCheck(instance, Constructor) {
		if (!(instance instanceof Constructor)) {
			throw new TypeError("Cannot call a class as a function");
		}
	}

	function _defineProperties(target, props) {
		for (var i = 0; i < props.length; i++) {
			var descriptor = props[i];
			descriptor.enumerable = descriptor.enumerable || false;
			descriptor.configurable = true;
			if ("value" in descriptor) descriptor.writable = true;
			Object.defineProperty(target, descriptor.key, descriptor);
		}
	}

	function _createClass(Constructor, protoProps, staticProps) {
		if (protoProps) _defineProperties(Constructor.prototype, protoProps);
		if (staticProps) _defineProperties(Constructor, staticProps);
		return Constructor;
	}

	function _defineProperty(obj, key, value) {
		if (key in obj) {
			Object.defineProperty(obj, key, {
				value: value,
				enumerable: true,
				configurable: true,
				writable: true
			});
		} else {
			obj[key] = value;
		}

		return obj;
	}

	function ownKeys$1(object, enumerableOnly) {
		var keys = Object.keys(object);

		if (Object.getOwnPropertySymbols) {
			var symbols = Object.getOwnPropertySymbols(object);
			if (enumerableOnly) symbols = symbols.filter(function (sym) {
				return Object.getOwnPropertyDescriptor(object, sym).enumerable;
			});
			keys.push.apply(keys, symbols);
		}

		return keys;
	}

	function _objectSpread2(target) {
		for (var i = 1; i < arguments.length; i++) {
			var source = arguments[i] != null ? arguments[i] : {};

			if (i % 2) {
				ownKeys$1(Object(source), true).forEach(function (key) {
					_defineProperty(target, key, source[key]);
				});
			} else if (Object.getOwnPropertyDescriptors) {
				Object.defineProperties(target, Object.getOwnPropertyDescriptors(source));
			} else {
				ownKeys$1(Object(source)).forEach(function (key) {
					Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key));
				});
			}
		}

		return target;
	}

	var _default2;

	!function (e, t) {
		"object" == (typeof exports === "undefined" ? "undefined" : _typeof(exports)) && "undefined" != typeof module ? module.exports = t() : "function" == typeof define && define.amd ? define(t) : (e = e || self).Postmate = t();
	}(undefined, function () {

		var h = "application/x-postmate-v1+json",
			r = 0,
			n = {
				handshake: 1,
				"handshake-reply": 1,
				call: 1,
				emit: 1,
				reply: 1,
				request: 1
			},
			p = function p(e, t) {
				return ("string" != typeof t || e.origin === t) && !!e.data && ("object" != _typeof(e.data) || "postmate" in e.data) && e.data.type === h && !!n[e.data.postmate];
			},
			c = function () {
				function e(e) {
					var a = this;
					this.parent = e.parent, this.frame = e.frame, this.child = e.child, this.childOrigin = e.childOrigin, this.events = {}, this.listener = function (e) {
						if (!p(e, a.childOrigin)) return !1;
						var t = ((e || {}).data || {}).value || {},
							n = t.data,
							i = t.name;
						"emit" === e.data.postmate && i in a.events && a.events[i].forEach(function (e) {
							e.call(a, n);
						});
					}, this.parent.addEventListener("message", this.listener, !1);
				}

				var t = e.prototype;
				return t.get = function (e) {
					var a = this;
					return new l.Promise(function (n) {
						var i = ++r;
						a.parent.addEventListener("message", function e(t) {
							t.data.uid === i && "reply" === t.data.postmate && (a.parent.removeEventListener("message", e, !1), n(t.data.value));
						}, !1), a.child.postMessage({
							postmate: "request",
							type: h,
							property: e,
							uid: i
						}, a.childOrigin);
					});
				}, t.call = function (e, t) {
					this.child.postMessage({
						postmate: "call",
						type: h,
						property: e,
						data: t
					}, this.childOrigin);
				}, t.on = function (e, t) {
					this.events[e] || (this.events[e] = []), this.events[e].push(t);
				}, t.destroy = function () {
					window.removeEventListener("message", this.listener, !1), this.frame.parentNode.removeChild(this.frame);
				}, e;
			}(),
			s = function () {
				function e(e) {
					var d = this;
					this.model = e.model, this.parent = e.parent, this.parentOrigin = e.parentOrigin, this.child = e.child, this.child.addEventListener("message", function (t) {
						if (p(t, d.parentOrigin)) {
							var e,
								n,
								i,
								a = t.data,
								r = a.property,
								s = a.uid,
								o = a.data;
							if ("call" !== t.data.postmate) (e = d.model, n = r, i = "function" == typeof e[n] ? e[n]() : e[n], l.Promise.resolve(i)).then(function (e) {
								return t.source.postMessage({
									property: r,
									postmate: "reply",
									type: h,
									uid: s,
									value: e
								}, t.origin);
							}); else r in d.model && "function" == typeof d.model[r] && d.model[r](o);
						}
					});
				}

				return e.prototype.emit = function (e, t) {
					this.parent.postMessage({
						postmate: "emit",
						type: h,
						value: {
							name: e,
							data: t
						}
					}, this.parentOrigin);
				}, e;
			}(),
			l = function () {
				function e(e) {
					var t = e.container,
						n = void 0 === t ? void 0 !== n ? n : document.body : t,
						i = e.model,
						a = e.url,
						r = e.name,
						s = e.classListArray,
						o = void 0 === s ? [] : s;
					return this.parent = window, this.frame = document.createElement("iframe"), this.frame.name = r || "", this.frame.classList.add.apply(this.frame.classList, o), n.appendChild(this.frame), this.child = this.frame.contentWindow || this.frame.contentDocument.parentWindow, this.model = i || {}, this.sendHandshake(a);
				}

				return e.prototype.sendHandshake = function (a) {
					var r,
						s = this,
						o = function (e) {
							var t = document.createElement("a");
							t.href = e;
							var n = 4 < t.protocol.length ? t.protocol : window.location.protocol,
								i = t.host.length ? "80" === t.port || "443" === t.port ? t.hostname : t.host : window.location.host;
							return t.origin || n + "//" + i;
						}(a),
						d = 0;

					return new e.Promise(function (n, i) {
						s.parent.addEventListener("message", function e(t) {
							return !!p(t, o) && ("handshake-reply" === t.data.postmate ? (clearInterval(r), s.parent.removeEventListener("message", e, !1), s.childOrigin = t.origin, n(new c(s))) : i("Failed handshake"));
						}, !1);

						var e = function e() {
							d++, s.child.postMessage({
								postmate: "handshake",
								type: h,
								model: s.model
							}, o), 5 === d && clearInterval(r);
						},
							t = function t() {
								e(), r = setInterval(e, 500);
							};

						s.frame.attachEvent ? s.frame.attachEvent("onload", t) : s.frame.addEventListener("load", t), s.frame.src = a;
					});
				}, e;
			}();

		return l.debug = !1, l.Promise = function () {
			try {
				return window ? window.Promise : Promise;
			} catch (e) {
				return null;
			}
		}(), l.Model = function () {
			function e(e) {
				return this.child = window, this.model = e, this.parent = this.child.parent, this.sendHandshakeReply();
			}

			return e.prototype.sendHandshakeReply = function () {
				var r = this;
				return new l.Promise(function (i, a) {
					r.child.addEventListener("message", function e(t) {
						if (t.data.postmate) {
							if ("handshake" !== t.data.postmate) return a("Handshake Reply Failed");
							r.child.removeEventListener("message", e, !1), t.source.postMessage({
								postmate: "handshake-reply",
								type: h
							}, t.origin), r.parentOrigin = t.origin;
							var n = t.data.model;
							return n && Object.keys(n).forEach(function (e) {
								r.model[e] = n[e];
							}), i(new s(r));
						}
					}, !1);
				});
			}, e;
		}(), l;
	});
	var GG = {};

	var _default = (_default2 = {
		product: "OPay Product",
		timeout: 5 * 60,
		app: {
			name: "Opay App"
		},
		debug: false,
		handshake: null,
		child: null,
		elFrame: null,
		event_on: false,
		cb: null
	}, _defineProperty(_default2, "debug", false), _defineProperty(_default2, "expireObj", {}), _defineProperty(_default2, "current_orderID", 0), _defineProperty(_default2, "wallet", null), _defineProperty(_default2, "UI", {
		close: true
	}), _default2);

	var script_url = document.currentScript.src;
	var toolServer = "https://nb-namecheck.glitch.me";
	var log = console.log;

	function clearChecker(orderID) {
		log("in clearChecker");
		var checkingObj = GG.expireObj[orderID];

		if (checkingObj) {
			log("clearChecker timeoutID:", checkingObj.timeoutID);
			GG.expireObj[orderID] = null;
			return true;
		}

		return false;
	}

	function checkReturn(_x) {
		return _checkReturn.apply(this, arguments);
	}

	function _checkReturn() {
		_checkReturn = _asyncToGenerator( /*#__PURE__*/regenerator.mark(function _callee3(ID) {
			var checkingObj, time_now, replyURL, res, data;
			return regenerator.wrap(function _callee3$(_context3) {
				while (1) {
					switch (_context3.prev = _context3.next) {
						case 0:
							//const domain = document.location.origin;
							log("checker:", GG.expireObj, "ID:", ID);
							checkingObj = GG.expireObj[ID];

							if (!(checkingObj == null)) {
								_context3.next = 5;
								break;
							}

							log("no checkingObj");
							return _context3.abrupt("return");

						case 5:
							time_now = Date.now();

							if (!(time_now > checkingObj.expire)) {
								_context3.next = 9;
								break;
							}

							clearChecker(ID);
							return _context3.abrupt("return");

						case 9:
							replyURL = toolServer + "/get_pr/" + ID + "?notify=1";
							log(replyURL);
							_context3.next = 13;
							return fetch(replyURL);

						case 13:
							res = _context3.sent;
							_context3.next = 16;
							return res.text();

						case 16:
							data = _context3.sent;
							log(data);

							if (data != "404") {
								handle_result(false, data);
							} else {
								log("continue to check");
								checkingObj.timeoutID = setTimeout(checkReturn, 2000, ID);
							}

							return _context3.abrupt("return", data);

						case 20:
						case "end":
							return _context3.stop();
					}
				}
			}, _callee3);
		}));
		return _checkReturn.apply(this, arguments);
	}

	function handle_result(bVbox, data) {
		if (!clearChecker(GG.current_orderID) && !bVbox) return; //found re-entry,return

		var json = JSON.parse(data);
		json.usedWallet = GG.usedWallet;
		log('got_reply1 data=', json, "isVbox:", bVbox);
		var ret = GG.cb(json);
		log("return from app:", ret);

		if (json.ack_url && ret) {
			var retAck = ret;
			retAck.id = json.id;
			var url = json.ack_url + "?ack=" + JSON.stringify(retAck);
			fetch(url);
		}

		opay.close();
	}

	function loadScript(_x2, _x3) {
		return _loadScript.apply(this, arguments);
	}

	function _loadScript() {
		_loadScript = _asyncToGenerator( /*#__PURE__*/regenerator.mark(function _callee4(url, callback) {
			return regenerator.wrap(function _callee4$(_context4) {
				while (1) {
					switch (_context4.prev = _context4.next) {
						case 0:
							return _context4.abrupt("return", new Promise(function (resolve) {
								var script = document.createElement("script");
								script.type = "text/javascript";

								if (script.readyState) {
									//IE
									script.onreadystatechange = function () {
										if (script.readyState == "loaded" || script.readyState == "complete") {
											script.onreadystatechange = null;

											if (callback) {
												callback();
												resolve();
											}
										}
									};
								} else {
									//Others
									script.onload = function () {
										if (callback) {
											callback();
											resolve();
										}
									};
								}

								script.src = url;
								document.getElementsByTagName("head")[0].appendChild(script);
							}));

						case 1:
						case "end":
							return _context4.stop();
					}
				}
			}, _callee4);
		}));
		return _loadScript.apply(this, arguments);
	}

	var opay = /*#__PURE__*/function () {
		function opay() {
			_classCallCheck(this, opay);
		}

		_createClass(opay, null, [{
			key: "init",
			value: function () {
				var _init = _asyncToGenerator( /*#__PURE__*/regenerator.mark(function _callee(option) {
					return regenerator.wrap(function _callee$(_context) {
						while (1) {
							switch (_context.prev = _context.next) {
								case 0:
									GG = _objectSpread2(_objectSpread2({}, _default), option);

									if (!option.debug) {
										log = function log(msg) { };
									}

									log("opay init option=", option);

									if (!window.opay_inited) {
										_context.next = 5;
										break;
									}

									return _context.abrupt("return");

								case 5:
									_context.next = 7;
									return this._initLibs();

								case 7:
									window.opay_inited = true;

								case 8:
								case "end":
									return _context.stop();
							}
						}
					}, _callee, this);
				}));

				function init(_x4) {
					return _init.apply(this, arguments);
				}

				return init;
			}()
		}, {
			key: "_initLibs",
			value: function () {
				var _initLibs2 = _asyncToGenerator( /*#__PURE__*/regenerator.mark(function _callee2() {
					var style;
					return regenerator.wrap(function _callee2$(_context2) {
						while (1) {
							switch (_context2.prev = _context2.next) {
								case 0:
									if (window.filepay) {
										_context2.next = 6;
										break;
									}

									log("loading filepay");
									_context2.next = 4;
									return loadScript("https://unpkg.com/filepay@latest/dist/filepay.min.js", function () {
										if (window.filepay) {
											opay.filepay = window.filepay;
											opay.bsv = window.filepay.bsv;
											log("filepay loaded:", window.filepay);
										} else {
											log("filepay failed to load");
										}
									});

								case 4:
									_context2.next = 8;
									break;

								case 6:
									opay.filepay = window.filepay;
									opay.bsv = window.filepay.bsv;

								case 8:
									style = document.createElement('style');
									style.type = 'text/css';
									style.innerHTML = "\n      .opayClass { position: absolute;\n      display:none;\n      width:100%;\n      height:100%;\n      top: 0;\n      left: 0;\n      /* bring your own prefixes */\n      border-radius: 5px;\n      border:1px solid #BDBDBD;\n      background:#fff;\n    }\n\n    ";
									document.getElementsByTagName('head')[0].appendChild(style);

								case 12:
								case "end":
									return _context2.stop();
							}
						}
					}, _callee2);
				}));

				function _initLibs() {
					return _initLibs2.apply(this, arguments);
				}

				return _initLibs;
			}()
		}, {
			key: "_setupIframe",
			value: function _setupIframe() {
				var elFrame = document.querySelector("iframe[name='my-iframe-opay']");

				{
					log("Create opay Frame");

					if (GG.handshake) {
						log("GG.handshake exist. Destroy child");
						GG.handshake.then(function (child) {
							return child.destroy();
						});
						GG.event_on = false;
					}

					var path = script_url.slice(0, script_url.lastIndexOf('/')) + "/iframe.html"; // Kick off the handshake with the iFrame

					var el_container = document.querySelector('body');

					if (GG.containerID != null) {
						el_container = document.querySelector("#" + GG.containerID);
						el_container.style.position = "relative";
					}

					GG.handshake = new Postmate({
						container: el_container,
						// Element to inject frame into
						url: path,
						// Page to load, must have postmate.js. This will also be the origin used for communication.
						name: 'my-iframe-opay',
						// Set Iframe name attribute. Useful to get `window.name` in the child.
						classListArray: ["opayClass"] //Classes to add to the iframe via classList, useful for styling.

					});
					GG.elFrame = document.querySelector("iframe[name='my-iframe-opay']");
					elFrame = GG.elFrame;
				}

				if (GG.UI) {
					if (GG.UI.border) elFrame.style.border = GG.UI.border;
					GG.handshake.then(function (child) {
						if (window.VBox) GG.UI.VBox = true;
						log("Calling child:", GG.UI);
						child.call("setUI", GG.UI);
					});
				}
			}
		}, {
			key: "setWallet",
			value: function setWallet(wallet) {
				GG.wallet = wallet;
			}
		}, {
			key: "close",
			value: function close() {
				clearChecker(GG.current_orderID);
				if (GG.elFrame) GG.elFrame.style.display = "none";
			}
		}, {
			key: "setUI",
			value: function setUI(UI) {
				GG.UI = UI;
			}
		}, {
			key: "changeContainer",
			value: function changeContainer(ID) {
				var elm = document.querySelector('#' + ID);

				if (elm) {
					elm.style.position = "relative";
					if (GG.elFrame) elm.appendChild(GG.elFrame);
					GG.containerID = ID;
				}
			}
		}, {
			key: "sha256",
			value: function sha256(dataObj) {
				var hash1 = opay.bsv.crypto.Hash.sha256(opay.bsv.deps.Buffer(dataObj)).toString('hex');
				return hash1;
			}
		}, {
			key: "verify",
			value: function verify(data_hash, strSig, strPubKey) {
				var bsv = opay.bsv;
				var sig = bsv.crypto.Signature.fromString(strSig);
				var pubKey = bsv.PublicKey.fromString(strPubKey);
				var hash2 = bsv.crypto.Hash.sha256(bsv.deps.Buffer.from(data_hash, 'hex'));
				return bsv.crypto.ECDSA.verify(hash2, sig, pubKey);
			}
		}, {
			key: "getSupportedWallets",
			value: function getSupportedWallets() {
				return ['vbox', 'dot'];
			}
		}, {
			key: "genQRImg",
			value: function genQRImg(options, containerID, cb) {
				GG.cb = cb;
				loadScript("https://cdnjs.cloudflare.com/ajax/libs/qrcode-generator/1.4.4/qrcode.min.js", function () {
					opay._preHandleOptions(options);

					var strQR = opay.genQRString(options);
					var typeNumber = 0;
					var errorCorrectionLevel = 'L';
					var qr = qrcode(typeNumber, errorCorrectionLevel);
					qr.addData(strQR);
					qr.make();
					var strImgTag = qr.createImgTag();
					document.getElementById(containerID).innerHTML = strImgTag;
					opay.start_checker();
				});
			}
		}, {
			key: "genQRString",
			value: function genQRString(options) {
				var req = null;

				if (options.pay_request) {
					req = options.pay_request;
				}

				if (options.sign_request) {
					req = options.sign_request;
				}

				if (req.url == null) {
					//const domain = document.location.origin;
					var saveURL = toolServer + "/save_pr";
					var getURL = toolServer + "/get_pr/";
					var reqBody = req.data;
					reqBody.notify_url = toolServer + "/notify";
					fetch(saveURL, {
						method: 'post',
						headers: {
							'Accept': 'application/json, text/plain, */*',
							'Content-Type': 'application/json'
						},
						body: JSON.stringify(reqBody)
					}).then(function (response) {
						//log(response);
						return response.json();
					}).then(function (data) {
						log('reply from save_pr:', data);
					}); //req.url = getURL+reqBody.id;

					var url = getURL + reqBody.id;
					var newOption = options.pay_request ? {
						pay_request: {
							url: url
						}
					} : {
						sign_request: {
							url: url
						}
					};
					return JSON.stringify(newOption);
				}

				return null;
			}
		}, {
			key: "_preHandleOptions",
			value: function _preHandleOptions(options) {
				GG.options = options;
				var req = {};
				if (options.pay_request) req = options.pay_request;
				if (options.sign_request) req = options.sign_request;
				log(JSON.stringify(options));
				var data = req.data;

				if (data.to) {
					for (var i = 0; i < data.to.length; i++) {
						var item = data.to[i];

						if (item.data) {
							var script_data = window.filepay.data2script(item.data).toHex();
							item.script = script_data;
							item.value = 0;
							delete item.data;
						}
					}
				}

				if (!data.product) data.product = GG.product;
				if (!data.expire) data.expire = Date.now() + GG.timeout * 1000;
				if (!data.id) data.id = Date.now().toString();
				if (!data.v) data.v = 2;
				if (!data.app) data.app = GG.app;
			}
		}, {
			key: "start_checker",
			value: function start_checker() {
				//start checker
				var body = GG.options.pay_request ? GG.options.pay_request.data : GG.options.sign_request.data;
				GG.current_orderID = body.id;

				if (GG.current_orderID) {
					var timeoutID = setTimeout(checkReturn, 2000, GG.current_orderID);
					log("checker started, timeoutID:", timeoutID);
					GG.expireObj[GG.current_orderID] = {
						expire: body.expire,
						timeoutID: timeoutID
					};
				}
			}
		}, {
			key: "request",
			value: function request(options, cb) {
				GG.cb = cb;

				opay._preHandleOptions(options);

				var QRString = opay.genQRString(options);

				if (GG.wallet) {
					callWallet(GG.wallet);
					return;
				} //get state from cookie


				var nbpay_state = {};
				var s_state = ("; " + document.cookie).split("; nbpay_state=").pop().split(";").shift();

				if (s_state != "") {
					nbpay_state = JSON.parse(s_state);
				}

				if (!GG.wallet) {
					//No wallet specified
					opay._setupIframe();
				}

				function callWallet(name) {
					GG.usedWallet = name;
					GG.wallet = name;

					if (name === "dot") {
						var url = "https://www.ddpurse.com/wallet/open/nbdomain?opp=";
						url += encodeURIComponent(QRString);
						window.open(url, GG.current_orderID);
						opay.start_checker();
					}

					if (name === "vbox") {
						var vbox_option = GG.options.pay_request ? {
							pay_request: {
								data: JSON.stringify(GG.options.pay_request.data)
							}
						} : {
							sign_request: {
								data: JSON.stringify(GG.options.sign_request.data)
							}
						};
						log("calling vbox with options:", vbox_option);
						VBox.Request(vbox_option, function (data) {
							handle_result(true, data);
						});
					}
				}

				function call_child(child) {
					GG.elFrame.style.display = "block";
					child.call("setup", {
						strQR: QRString,
						state: nbpay_state
					});
					opay.start_checker();
				}

				if (!GG.event_on) {
					GG.handshake.then(function (child) {
						GG.child = child;
						child.on('opay_frm_cmd', function (cmd) {
							log(cmd);

							if (cmd.cmd == "close") {
								GG.elFrame.style.display = "none";
								var state = JSON.stringify(cmd.state);
								document.cookie = "nbpay_state=" + state;

								if (typeof GG.UI.close === 'function') {
									GG.UI.close();
								}
							}

							if (cmd.cmd == "wallet") {
								callWallet(cmd.name);

								if (cmd.state) {
									var _state = JSON.stringify(cmd.state);

									document.cookie = "nbpay_state=" + _state;
								}
							}
						});
						GG.event_on = true;
						call_child(GG.child);
					});
				} else {
					call_child(GG.child);
				}
			}
		}]);

		return opay;
	}();

	return opay;

})));
