
function connectWebViewJavascriptBridge(callback) {
    if (window.WebViewJavascriptBridge) {
        callback(WebViewJavascriptBridge)
    } else {
        document.addEventListener(
            'WebViewJavascriptBridgeReady'
            , function () {
                callback(WebViewJavascriptBridge)
            },
            false
        );
    }
}


(function () {
    if (window.maxthon.V) {
        return;
    }
    var V =  window.V = window.maxthon.V = {
        createVBox: function (callback, password, avatar_type, avatar_data, name) {
            var json = {
                password: password, avatar_type: avatar_type, avatar_data: avatar_data, name: name
            };
            connectWebViewJavascriptBridge(function () {
                WebViewJavascriptBridge.callHandler(
                    'callVBox',
                    { "action": "createVBox", "data": JSON.stringify(json) },
                    function (responseData) {
                        callback(responseData);
                    }
                );
            });
        },
        deleteVBox: function (callback, password, public_key) {
            var json = {
                password: password, public_key: public_key
            };
            connectWebViewJavascriptBridge(function () {
                WebViewJavascriptBridge.callHandler(
                    'callVBox',
                    { "action": "deleteVBox", "data": JSON.stringify(json) },
                    function (responseData) {
                        callback(responseData);
                    }
                );
            });
        },
        modifyVBox: function (callback, public_key, type, data) {
            var json = {
                public_key: public_key, type: type, data: data
            };
            connectWebViewJavascriptBridge(function () {
                WebViewJavascriptBridge.callHandler(
                    'callVBox',
                    { "action": "modifyVBox", "data": JSON.stringify(json) },
                    function (responseData) {
                        callback(responseData);
                    }
                );
            });
        },
        modifyVBoxAvatar: function (callback, public_key, avatar_type, avatar_data) {
            var json = {
                public_key: public_key, avatar_type: avatar_type, avatar_data: avatar_data
            };
            connectWebViewJavascriptBridge(function () {
                WebViewJavascriptBridge.callHandler(
                    'callVBox',
                    { "action": "modifyVBoxAvatar", "data": JSON.stringify(json) },
                    function (responseData) {
                        callback(responseData);
                    }
                );
            });
        },
        resetVBoxPassword: function (callback, public_key, old_password, new_password) {
            var json = {
                public_key: public_key, old_password: old_password, new_password: new_password
            };
            connectWebViewJavascriptBridge(function () {
                WebViewJavascriptBridge.callHandler(
                    'callVBox',
                    { "action": "resetVBoxPassword", "data": JSON.stringify(json) },
                    function (responseData) {
                        callback(responseData);
                    }
                );
            });
        },
        exportVBox: function (callback) {
            connectWebViewJavascriptBridge(function () {
                WebViewJavascriptBridge.callHandler(
                    'callVBox',
                    { "action": "exportVBox", "data": JSON.stringify({}) },
                    function (responseData) {
                        callback(responseData);
                    }
                );
            });
        },
        importVBox: function (callback) {
            connectWebViewJavascriptBridge(function () {
                WebViewJavascriptBridge.callHandler(
                    'callVBox',
                    { "action": "importVBox", "data": JSON.stringify({}) },
                    function (responseData) {
                        callback(responseData);
                    }
                );
            });
        },
        getVBoxs: function (callback) {
            connectWebViewJavascriptBridge(function () {
                WebViewJavascriptBridge.callHandler(
                    'callVBox',
                    { "action": "getVBoxs", "data": JSON.stringify({}) },
                    function (responseData) {
                        callback(responseData);
                    }
                );
            });
        },
        clearVBox: function (callback, clear_cloud) {
            var json = {
                clear_cloud: clear_cloud
            };
            connectWebViewJavascriptBridge(function () {
                WebViewJavascriptBridge.callHandler(
                    'callVBox',
                    { "action": "clearVBox", "data": JSON.stringify(json) },
                    function (responseData) {
                        callback(responseData);
                    }
                );
            });
        },
        loginCloud: function (callback, email, token) {
            var json = {
                email: email, token: token
            };

            connectWebViewJavascriptBridge(function () {
                WebViewJavascriptBridge.callHandler(
                    'callVBox',
                    { "action": "loginCloud", "data": JSON.stringify(json) },
                    function (responseData) {
                        callback(responseData);
                    }
                );
            });
        },
        closeCloud: function (callback) {
            connectWebViewJavascriptBridge(function () {
                WebViewJavascriptBridge.callHandler(
                    'callVBox',
                    { "action": "closeCloud", "data": JSON.stringify({}) },
                    function (responseData) {
                        callback(responseData);
                    }
                );
            });
        },
        getCloudStatus: function (callback) {
            connectWebViewJavascriptBridge(function () {
                WebViewJavascriptBridge.callHandler(
                    'callVBox',
                    { "action": "getCloudStatus", "data": JSON.stringify({}) },
                    function (responseData) {
                        callback(responseData);
                    }
                );
            });
        },
        getSignDatas: function (callback, public_key, password) {
            var json = {
                public_key: public_key, password: password
            };
            connectWebViewJavascriptBridge(function () {
                WebViewJavascriptBridge.callHandler(
                    'callVBox',
                    { "action": "getSignDatas", "data": JSON.stringify(json) },
                    function (responseData) {
                        callback(responseData);
                    }
                );
            });
        },
        addSignData: function (callback, js_object) {
            connectWebViewJavascriptBridge(function () {
                WebViewJavascriptBridge.callHandler(
                    'callVBox',
                    { "action": "addSignData", "data": JSON.stringify(js_object) },
                    function (responseData) {
                        callback(responseData);
                    }
                );
            });
        },
        modifySignData: function (callback, js_object) {
            connectWebViewJavascriptBridge(function () {
                WebViewJavascriptBridge.callHandler(
                    'callVBox',
                    { "action": "modifySignData", "data": JSON.stringify(js_object) },
                    function (responseData) {
                        callback(responseData);
                    }
                );
            });
        },
        deleteSignData: function (callback, public_key, id) {
            var json = {
                public_key: public_key, id: id
            };
            connectWebViewJavascriptBridge(function () {
                WebViewJavascriptBridge.callHandler(
                    'callVBox',
                    { "action": "deleteSignDatas", "data": JSON.stringify(json) },
                    function (responseData) {
                        callback(responseData);
                    }
                );
            });
        },
        getPayDatas: function (callback, public_key, password) {
            var json = {
                public_key: public_key, password: password
            };

            connectWebViewJavascriptBridge(function () {
                WebViewJavascriptBridge.callHandler(
                    'callVBox',
                    { "action": "getPayDatas", "data": JSON.stringify(json) },
                    function (responseData) {
                        callback(responseData);
                    }
                );
            });
        },
        addPayData: function (callback, js_object) {
            connectWebViewJavascriptBridge(function () {
                WebViewJavascriptBridge.callHandler(
                    'callVBox',
                    { "action": "addPayData", "data": JSON.stringify(js_object) },
                    function (responseData) {
                        callback(responseData);
                    }
                );
            });
        },
        modifyPayData: function (callback, js_object) {
            connectWebViewJavascriptBridge(function () {
                WebViewJavascriptBridge.callHandler(
                    'callVBox',
                    { "action": "modifyPayData", "data": JSON.stringify(js_object) },
                    function (responseData) {
                        callback(responseData);
                    }
                );
            });
        },
        deletePayData: function (callback, public_key, id) {
            var json = {
                public_key: public_key, id: id
            };
            connectWebViewJavascriptBridge(function () {
                WebViewJavascriptBridge.callHandler(
                    'callVBox',
                    { "action": "deletePayData", "data": JSON.stringify(json) },
                    function (responseData) {
                        callback(responseData);
                    }
                );
            });
        },
        getPassQuota: function (callback, public_key) {
            var json = {
                public_key: public_key
            };

            connectWebViewJavascriptBridge(function () {
                WebViewJavascriptBridge.callHandler(
                    'callVBox',
                    { "action": "getPassQuota", "data": JSON.stringify(json) },
                    function (responseData) {
                        callback(responseData);
                    }
                );
            });
        },
        setPassQuota: function (callback, public_key, password, quota) {
            var json = {
                public_key: public_key, password: password, quota: quota
            };

            connectWebViewJavascriptBridge(function () {
                WebViewJavascriptBridge.callHandler(
                    'callVBox',
                    { "action": "setPassQuota", "data": JSON.stringify(json) },
                    function (responseData) {
                        callback(responseData);
                    }
                );
            });
        },
        getDayPassQuota: function (callback, public_key) {
            var json = {
                public_key: public_key
            };

            connectWebViewJavascriptBridge(function () {
                WebViewJavascriptBridge.callHandler(
                    'callVBox',
                    { "action": "getDayPassQuota", "data": JSON.stringify(json) },
                    function (responseData) {
                        callback(responseData);
                    }
                );
            });
        },
        setDayPassQuota: function (callback, public_key, password, quota) {
            var json = {
                public_key: public_key, password: password, quota: quota
            };

            connectWebViewJavascriptBridge(function () {
                WebViewJavascriptBridge.callHandler(
                    'callVBox',
                    { "action": "setDayPassQuota", "data": JSON.stringify(json) },
                    function (responseData) {
                        callback(responseData);
                    }
                );
            });
        },
        authorizeConfirm: function (callback, json_string) {
            connectWebViewJavascriptBridge(function () {
                WebViewJavascriptBridge.callHandler(
                    'callVBox',
                    { "action": "authorizeConfirm", "data": json_string },
                    function (responseData) {
                        callback(responseData);
                    }
                );
            });
        },
        getFee: function (callback, json_string) {
            connectWebViewJavascriptBridge(function () {
                WebViewJavascriptBridge.callHandler(
                    'callVBox',
                    { "action": "getFee", "data": json_string },
                    function (responseData) {
                        callback(responseData);
                    }
                );
            });
        },
        payConfirm: function (callback, json_string) {
            connectWebViewJavascriptBridge(function () {
                WebViewJavascriptBridge.callHandler(
                    'callVBox',
                    { "action": "payConfirm", "data": json_string },
                    function (responseData) {
                        callback(responseData);
                    }
                );
            });
        },
        signAuthorizeConfirm: function (callback, json_string) {
            connectWebViewJavascriptBridge(function () {
                WebViewJavascriptBridge.callHandler(
                    'callVBox',
                    { "action": "signAuthorizeConfirm", "data": json_string },
                    function (responseData) {
                        callback(responseData);
                    }
                );
            });
        },
        signConfirm: function (callback, json_string) {
            connectWebViewJavascriptBridge(function () {
                WebViewJavascriptBridge.callHandler(
                    'callVBox',
                    { "action": "signConfirm", "data": json_string },
                    function (responseData) {
                        callback(responseData);
                    }
                );
            });
        },
        setDefaultIdentity: function (callback, json_string) {
            var json = {
                address: json_string
            };
            connectWebViewJavascriptBridge(function () {
                WebViewJavascriptBridge.callHandler(
                    'callVBox',
                    { "action": "setDefaultIdentity", "data": JSON.stringify(json) },
                    function (responseData) {
                        callback(responseData);
                    }
                );
            });
        },
        registerSyncEvent: function (callback) {
            connectWebViewJavascriptBridge(function () {
                WebViewJavascriptBridge.registerHandler(
                    'onMaxthonVboxSyncEventCallback',
                    function(data, responseCallback) {
                        responseCallback(callback(data));
                    });
            });
        },

        scanQRCode: function (callback) {
            connectWebViewJavascriptBridge(function () {
                WebViewJavascriptBridge.callHandler(
                    'callVBox',
                    { "action": "scanQRCode", "data": JSON.stringify({}) },
                    function (responseData) {
                        callback(responseData);
                    }
                );
            });
        },
        passwordCorrect: function (callback, public_key, password) {
            var json = {
                public_key: public_key, password: password
            };
            connectWebViewJavascriptBridge(function () {
                WebViewJavascriptBridge.callHandler(
                    'callVBox',
                    { "action": "passwordCorrect", "data": JSON.stringify(json) },
                    function (responseData) {
                        callback(responseData);
                    }
                );
            });
        },
        verifyPrivateKey: function (callback, key) {
            var json = {
                key: key
            };
            connectWebViewJavascriptBridge(function () {
                WebViewJavascriptBridge.callHandler(
                    'callVBox',
                    { "action": "verifyPrivateKey", "data": JSON.stringify(json) },
                    function (responseData) {
                        callback(responseData);
                    }
                );
            });
        },
        importPrivateKey: function (callback, private_key, password, name) {
            var json = {
                private_key: private_key, password: password, name: name
            };
            connectWebViewJavascriptBridge(function () {
                WebViewJavascriptBridge.callHandler(
                    'callVBox',
                    { "action": "importPrivateKey", "data": JSON.stringify(json) },
                    function (responseData) {
                        callback(responseData);
                    }
                );
            });
        },
        
        updateNBdomain: function (callback, domain, address, json_object) {
            var json = {
                domain: domain, address: address, json_object: json_object
            };
            connectWebViewJavascriptBridge(function () {
                WebViewJavascriptBridge.callHandler(
                    'callVBox',
                    { "action": "updateNBdomain", "data": JSON.stringify(json) },
                    function (responseData) {
                        callback(responseData);
                    }
                );
            });
        },
        registNotifyFunction: function (callback) {
            connectWebViewJavascriptBridge(function () {
                WebViewJavascriptBridge.registerHandler(
                    'onMaxthonVboxWebNotifyEventCallback',
                    function(data, responseCallback) {
                        responseCallback(callback(data));
                    });
            });
        },
        payIDConfirm: function (callback,id, confirm) {
            var json = {
                id: id, confirm: confirm
            };
            connectWebViewJavascriptBridge(function () {
                WebViewJavascriptBridge.callHandler(
                    'callVBox',
                    { "action": "payIDConfirm", "data": JSON.stringify(json) },
                    function (responseData) {
                        callback(responseData);
                    }
                );
            });
        },
        close:function() {
            connectWebViewJavascriptBridge(function () {
                WebViewJavascriptBridge.callHandler(
                    'callVBox',
                    { "action": "close", "data": JSON.stringify({}) },
                    function (responseData) {
                    }
                );
            });
        }
    };

    var readyEvent = document.createEvent('Events');
    readyEvent.initEvent('VBoxReady');
    readyEvent.V = V;
    document.dispatchEvent(readyEvent);
})();

